import java.io.*;
import java.lang.*;
import java.sql.*;
import java.util.*;


class TestTrans
{
	public static void main(String argv[]) throws IOException
	{
		Connection db;
		Statement s;
		String fileIn;
		FileInputStream fin=null;
		int row=0;
		String tokena,tokenb;
		boolean vfAutoCommit;

		// Load the driver
		try
		{
            Class.forName(argv[0]);
		} catch (ClassNotFoundException e) {
			System.err.println("Exception: " + e.toString());
      }

      if(argv.length >4)
         fileIn=argv[4];
      else
         fileIn="TestTrans.sql";

      System.out.println("File Input : "+fileIn);

      try
      {
         fin= new FileInputStream (fileIn);
      }catch (FileNotFoundException e)
      {
         System.out.println("Error while try open file");
      }

      DataInputStream d = new DataInputStream(fin);

      Hashtable ListConn=new Hashtable();
		// Lets do a few things -- it doesn't do everything, but
		// it tests out basic functionality
		try
		{

  	  if ( d!=null )
	  {
    	while(d.available()>0)
        {
            String strline=d.readLine();
            row++;
            StringTokenizer st = new StringTokenizer(strline, " \t\n\r");
    	    if (st.countTokens()>0)
    		{
        		tokena = st.nextToken();
        		System.out.println(tokena);
        		Integer itokena=new Integer(tokena);
              if((db=(Connection) ListConn.get(itokena))==null)
              {
                  System.out.println("Connecting to Database URL = " + argv[1]);
                  db = DriverManager.getConnection(argv[1], argv[2], argv[3]);

                    System.out.println("AutoCommit : false");
                    db.setAutoCommit(false);
                    db.setTransactionIsolation(Connection.TRANSACTION_READ_UNCOMMITTED);
                    vfAutoCommit=false;

        		    System.out.println("Connected...Now creating a statement");

                ListConn.put(itokena,db);
              }

                  s = db.createStatement();

        		tokenb = st.nextToken();


                		if ((!tokenb.equalsIgnoreCase("extended"))||(argv[0].indexOf("iddb")!=-1))
                		{
                		    long vfTimerStart=System.currentTimeMillis();
//		    s = db.createStatement(); String
                            String query=strline.substring(strline.indexOf(tokenb));
                		    if(tokenb.equalsIgnoreCase("select"))
                		    {
                		        ResultSet rs=s.executeQuery(query);
                                if(rs!=null)
                                {
                                	int i = 0;
                                	String tmp="";
                                	ResultSetMetaData rsmd=rs.getMetaData();
                                	int nf=rsmd.getColumnCount();
                                	while (rs.next())
                                	{
                                		System.out.print("row(" + i + "):");
                                	    for(int x=1;x<=nf;x++)
                                	    {
                                            switch (rsmd.getColumnType(x))
                                            {
                                                case Types.CHAR:
                                                case 12:
                                                    tmp=rs.getString(x);
                                                    break;
                                                case Types.INTEGER:
                                                    tmp=""+rs.getInt(x);
                                                    break;
                                                case Types.FLOAT:
                                                    tmp=""+rs.getFloat(x);
                                                    break;
                                                default:
                                                    System.out.println("Type : "+rsmd.getColumnType(x)+" float type : "+Types.FLOAT+" double type : "+Types.DOUBLE+" double type : "+Types.DOUBLE);
                                                    tmp=""+rs.getFloat(x);
                                                    break;
                                            }
                                		    System.out.print("|"+tmp);
                                        }
                                		System.out.println("|");
                                		i++;
                                	}
                                }
                		    }
                		    else
                		    if(tokenb.equalsIgnoreCase("commit"))
                		    try {
                		        db.commit();
                        	} catch (SQLException e) {
                        	    System.out.println("Exception: " + e.toString());
                        	}
                		    else
                		    {
                		        System.out.println(query);
                		        s.executeUpdate(query);
                		    }
//		    s.close();
                		    long vfTimerEnd=System.currentTimeMillis();
                		    long vfTime=vfTimerEnd-vfTimerStart;
    //            		    System.out.println("Row: "+row+" "+(vfTimerEnd-vfTimerStart)+" milisecond: "+strline);
            		        System.out.println(vfTime);
                		}
   		                s.close();

                	}
                }
            }
    	    System.out.println("Now closing the connection");
    	    d.close();
            fin.close();

            for(Enumeration e=ListConn.elements();e.hasMoreElements();)
            {
                ((Connection)e.nextElement()).close();
            }

    	} catch (SQLException e) {
    	    System.out.println("Exception: " + e.toString());
    	}
	}
}
