/**
 *
 * FileConfig.java
 *
 * Copyright 1998, Junus Junarto D
 *                 (junus@its.ac.id)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * @version 0.1.0 1-MARCH-1998
 *
 */

package iddb;
//FileInputStreamTest.java


import java.io.*;
import java.util.*;

// read a single byte followed by a byte array from a file called "junk"
public class FileConfig {
    Properties plocal = new Properties();
    Properties pdbmslocal = new Properties();
    String fileIn="JDBCIDDB.ini";

    public FileConfig() throws IOException
    {
	    initfile();
    }

    void initfile() throws IOException
    {
    	FileInputStream f = null;
    	String tokena=null,tokenb=null;
    	int state=1;

    	f = openfile(fileIn);
    	DataInputStream d = new DataInputStream(f);
    	if ( d!=null )
    	{
        	while(d.available()>0)
            {
                String strline=d.readLine();
                strline.toLowerCase();

                StringTokenizer st = new StringTokenizer(strline, "= ");
        	    if (st.countTokens()>0)
        		{
            		tokena = st.nextToken();
            		if (st.countTokens()==0)
            		{
            		    if(tokena.equals("[local]"))
            			state=1;
            		    else if(tokena.equals("[dbmslocal]"))
            			state=2;
            		}
            		else
            		{
            		    tokenb = st.nextToken();
            		    switch(state)
            		    {
            			case 1:
            					plocal.put(tokena,tokenb);
            					break;
            			case 2:
            					pdbmslocal.put(tokena,tokenb);
            					break;
            			}
            		}
            	}
    	    }

    	    d.close();
    	    f.close();  // close and free up system resource.
    	}
    }

    FileInputStream openfile(String fileIn) throws IOException
    {
        FileInputStream fin;
        try
        {
            fin= new FileInputStream (fileIn);
        }catch (FileNotFoundException e)
        {
            String[] data = { "[local]",
                            "local = off",
                            "",
                            "[dbmslocal]",
  	                        "driver = interbase.interclient.Driver",
                            "url = jdbc:interbase://junus/d:\\data\\ta\\program\\perpus\\perpus.gdb",
                            "user = junus",
                            "password = junarto"};
            FileOutputStream fout = new FileOutputStream (fileIn);
            for(int i=0;i<data.length;i++)
            {
                for(int j=0;j<data[i].length();j++)
                    fout.write((int)data[i].charAt(j));
                fout.write((int)'\r');
                fout.write((int)'\n');
            }
            fout.close();
            fin= new FileInputStream (fileIn);
        }
        return fin;
    }

    public Properties getLocal()
    {
        return plocal;
    }

    public Properties getDBMSLocal()
    {
        return pdbmslocal;
    }
}

