/**
 *
 * IDDBObject.java
 *
 * Copyright 1998, Junus Junarto D
 *                 (junus@its.ac.id)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * @version 0.1.0 1-MARCH-1998
 *
 * iddb.IDDB_Object is a class used to describe unknown types
 * An unknown type is any type that is unknown by JDBC Standards
 *
 */
package iddb;

import java.lang.*;
import java.sql.*;
import java.util.*;
import iddb.*;

public class IDDBObject
{
  public String	type;
  public String	value;

  /**
   *	Constructor for the IDDB generic object
   *
   * @param type a string describing the type of the object
   * @param value a string representation of the value of the object
   */
  public IDDBObject(String type, String value) throws SQLException
  {
    this.type = type;
    this.value = value;
  }

}
