import java.util.*;
import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;
import java.sql.*;

class CommunicationManager
{
    private ErrorManager vcError;
    private int vcDebugLevel;

    private Hashtable vcConnectorList = new Hashtable();
    private int vcPort = 9301; // default port : 9301, because my NRP is 2693100001

    private ServerSocket vcConnection;

    private UserAuthentication vcUserAuthentication;
    private TransactionManager vcTransactionManager;

    private int vcConnectorNo=0;
    private Integer vcConnectorNoCurrent;

    private int vcOptimizerType;

    public CommunicationManager(UserAuthentication vpUserAuthentication, int vpOptimizerType, ErrorManager vpError, int vpDebugLevel)
    {
        vcUserAuthentication=vpUserAuthentication;
        vcOptimizerType=vpOptimizerType;

        vcError=vpError;
        vcDebugLevel=vpDebugLevel;
    }

    public void fInsertTransactionManager(TransactionManager vpTransactionManager)
    {
        vcTransactionManager=vpTransactionManager;
    }

    public void fRun() throws IOException
    {
        vcConnection = new ServerSocket(vcPort);
        while(true)
        {
//            if(vcDebugLevel>=1)
                System.out.println("Wait for ConnectorNo : "+vcConnectorNo);
            Integer vfConnectorNo = new Integer(vcConnectorNo++);
Socket vfConnection=vcConnection.accept();
//                System.out.println("Wait for XXXXX ConnectorNo : "+vcConnectorNo);
            Connector vfConnector = new Connector(this, vcOptimizerType, vfConnectorNo, vfConnection,
                vcUserAuthentication, vcError, vcDebugLevel);
            if(vfConnector.connected)
                vcConnectorList.put(vfConnectorNo,vfConnector);
        }
    }

    public synchronized ResultOut fPutQuery(Integer vpConnectorNo, boolean vpAutoCommit,int vpTransactionLevel, String vpQuery,String vpUser, int vpUserLevel)
    {
        vcConnectorNoCurrent=vpConnectorNo;
        return vcTransactionManager.fPutQuery(vpConnectorNo, vpAutoCommit, vpTransactionLevel, vpQuery,vpUser, vpUserLevel);
    }

    public void close() throws IOException
    {
        for (Enumeration vfEn = vcConnectorList.elements() ; vfEn.hasMoreElements() ;)
        {
            Connector vfConnector=(Connector) vfEn.nextElement();
	        if (vfConnector!=null)
                vfConnector.destroy();
        }
    }

    public synchronized void fExecuteQueryEnd()
    {
        vcTransactionManager.fExecuteQueryEnd();
    }

    public int fGetConnectorCount()
    {
        return vcConnectorList.size();
    }

    public void fPutError(String vpError)
    {
        ((Connector)vcConnectorList.get(vcConnectorNoCurrent)).fPutError(vpError);
    }

    public void fPutWarning(String vpWarning)
    {
        ((Connector)vcConnectorList.get(vcConnectorNoCurrent)).fPutWarning(vpWarning);
    }

    public void fRemoveConnector(Integer vpConnectorNo, boolean vpAutoCommit,int vpTransactionLevel )
    {
        vcTransactionManager.fRemoveTransaction(vpConnectorNo, vpAutoCommit, vpTransactionLevel,null );
        vcConnectorList.remove(vpConnectorNo);
    }
}
