import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;
import java.sql.*;
/*
    This class is a simple extention of Canvas that runs as it's own
    thread.  It runs a simple animation.
 */
class Connector implements Runnable
{
    String IDDB_DATABASE;
    String IDDB_PASSWORD;
    String IDDB_USER;
    int IDDB_PORT;
    String IDDB_HOST;
    boolean IDDB_STATUS;

    String this_url;
    int vcOptimizerType=IDDBConstants.OPTIMIZER_SEMIJOIN;
    static private boolean CONNECTION_BAD=false;
    static private boolean CONNECTION_OK=true;

    private IDDBStream vcIDDBStream;

    static private int STARTUP_CODE = 9301;

    Thread  vcSThread;
    public boolean connected = false;

    int vcUserLevel;

    Integer vcConnectorNo;

    private ErrorManager vcError;
    private int vcDebugLevel;

    private CommunicationManager vcCommunicationManager;

    private boolean[] vcFieldSiteId;
    private int vcFieldCountMinus;
    private boolean vcExitGood=false;

    private int vcTransactionLevel=Connection.TRANSACTION_READ_UNCOMMITTED;
    private boolean vcAutoCommit=true;
    private boolean vcCommit=false;

    public Connector(CommunicationManager vpCommunicationManager, int vpOptimizerType, Integer vpConnectorNo, Socket vpSocket,
        UserAuthentication vpUserAuthentication, ErrorManager vpError, int vpDebugLevel) throws IOException
    {
        vcError=vpError;
        vcDebugLevel=vpDebugLevel;

        vcOptimizerType=vpOptimizerType;
        vcCommunicationManager=vpCommunicationManager;
	    vcIDDBStream = new IDDBStream(vpSocket);
        vcConnectorNo=vpConnectorNo;
        String vfDatabase;
        int vfLen,vfStartupCode;

        try
	    {
	        vfLen=vcIDDBStream.ReceiveInteger(4);
	        if(vcDebugLevel>=1)
	            System.out.println("vfLen : "+vfLen);
            vfLen -= 4;

	        vfStartupCode=vcIDDBStream.ReceiveInteger(4);		vfLen -= 4;
	        if(vcDebugLevel>=1)
    	        System.out.println("vfStartupCode : "+vfStartupCode);

	        vfDatabase= new String((byte[])vcIDDBStream.Receive(20));	vfLen -= 20;
	        if(vcDebugLevel>=1)
    	        System.out.println("vfDatabase : "+vfDatabase);

	        byte[] buf=vcIDDBStream.Receive(20);
	        IDDB_USER=new String(buf);    vfLen -= 20;
	        IDDB_USER=IDDB_USER.trim();
	        if(vcDebugLevel>=1)
    	        System.out.println("IDDB_USER : "+IDDB_USER);

	        IDDB_PASSWORD=new String((byte[])vcIDDBStream.Receive(vfLen));
	        IDDB_PASSWORD=IDDB_PASSWORD.trim();
	        if(vcDebugLevel>=1)
        		System.out.println("IDDB_PASSWORD : "+IDDB_PASSWORD);

    		int vfUserAuthentication;
    		if(!vfDatabase.trim().equals("iddb"))
    		{
    		    vfUserAuthentication=3;
    		}
    		else
    		{
    		    vfUserAuthentication=vpUserAuthentication.passwd(IDDB_USER,IDDB_PASSWORD);
    		    vcUserLevel=vpUserAuthentication.getLevel();
    		}
    		send_result(vfUserAuthentication, IDDB_USER, IDDB_DATABASE);
    		if(vfUserAuthentication==0)
    		{
    			vcSThread = new Thread(this);
    			vcSThread.start();
    			connected=true;
    		}else vcIDDBStream.close();
	    } catch (IOException vfEx) {
		throw new IOException("1401, Connector Error : While initialisation, Exception: " + vfEx.toString());
	    }
    }

    public void send_result(int vpI, String user, String database) throws IOException
    {
	    switch(vpI)
	    {
	        case 0 :
	                vcIDDBStream.SendChar('O');
	                if(vcDebugLevel>=1)
	                    System.out.println("Connector no "+vcConnectorNo+" is connected");
	                break;
	        case 1 :
        		    vcError.fPutError(1402,"Connector Error : User: "+user+" not found !");
        		    fPutError("Connector Error : User: "+user+" not found !");
        		    //keluarkan ke vcIDDBStream
	                break;
	        case 2 :
        		    vcError.fPutError(1403,"Connector Error : Password not valid !");
        		    fPutError("Connector Error : Password not valid !");
        		    //keluarkan ke vcIDDBStream
	                break;
	        case 3 :
        		    vcError.fPutError(1404,"Connector Error : Database: "+database+" not valid, always use database: 'iddb'");
        		    fPutError("Connector Error : Database: "+database+" not valid, always use database: 'iddb'");
        		    //keluarkan ke vcIDDBStream
	                break;
	    }
	}

    public void resume() { vcSThread.resume(); }


    public boolean execute()
    {
        boolean vfExit=false;

        try
        {
	        int vfChar = vcIDDBStream.ReceiveChar();

    	    switch (vfChar)
    	    {
                case 'Q':
//                    vfExit=
                    fQuery();
                    break;
                case 'A':
	                int vfCharx = vcIDDBStream.ReceiveChar();
	                switch(vfCharx)
	                {
	                    case 'Y': vcAutoCommit=true; break;
	                    case 'N': vcAutoCommit=false; break;
	                }
                case 'L':
	                vcTransactionLevel=vcIDDBStream.ReceiveInteger(4);
	                break;
                case 'S':
                    vcExitGood=true;
   	                vcIDDBStream.SendChar('S');
                    break;
            }
	    } catch (IOException vfEx) {
	        if(vcExitGood)
//    	        if(vcDebugLevel>=1)
    	            System.out.println("Connector no : "+vcConnectorNo+" normal out.");
	        else
	            vcError.fPutError(1405,"Connector Error : Connector No : "+vcConnectorNo+" abnormal out !, Exception: " + vfEx.toString());
	        if(vcCommit)
	            vcAutoCommit=true;
            vcCommunicationManager.fRemoveConnector(vcConnectorNo,vcAutoCommit,vcTransactionLevel);
            try
            {
    	        vcIDDBStream.close();
    	    } catch (IOException vfEx2) {}
	        vfExit=true;
	    }
        return vfExit;
    }

    public synchronized boolean fQuery()throws IOException
    {
        boolean vfExit=false;
        String vfQuery=vcIDDBStream.ReceiveString(1000);
        ResultOut vfRSOut=vcCommunicationManager.fPutQuery(vcConnectorNo,vcAutoCommit,vcTransactionLevel,vfQuery,IDDB_USER,vcUserLevel);
        if((vfRSOut!=null)&&((vfRSOut.command==IDDBConstants.COMMAND_COMMIT)||(vfRSOut.command==IDDBConstants.COMMAND_ROLLBACK)))
        {
//            vfExit= true;
            vcExitGood=true;
            vcCommit=true;
            vcIDDBStream.SendChar('S');
        }
        else
        if(vfRSOut!=null)
        {
            if(vfRSOut.command==IDDBConstants.COMMAND_SELECT)
            {
                fPutRSOut(vfRSOut);
                vcCommunicationManager.fExecuteQueryEnd();
            }
            else
                fPutRSi(vfRSOut.RSi);
        }
        return vfExit;
    }

    public void fSendTuple(int vpFieldCount, ResultSet vpRS, ResultSetMetaData vpRSMD) throws IOException
    {
        int vfI, vfBim = (vpFieldCount - vcFieldCountMinus + 7)/8;
        byte[] vfBitmask = new byte[vfBim];
        byte[][] vfAnswer = new byte[vpFieldCount][0];

        if(vcDebugLevel>=1)
            System.out.println("Print data :");

        try
        {
            while(vpRS.next())
            {
                int vfWhichBit = 0x80;
                int vfWhichByte = 0;
            	vfBitmask[vfWhichByte]=0;

                for (vfI = 0 ; vfI < vpFieldCount ; ++vfI)
                {
                    if(vcFieldSiteId[vfI])
                    {
                        int vfColumnType=vpRSMD.getColumnType(vfI+1);
                        String vfBuffer="";
                        switch(vfColumnType)
                        {
                            case Types.CHAR:
                                vfBuffer = vpRS.getString(vfI+1);
                	            break;
                            case Types.INTEGER:
                                vfBuffer = Integer.toString(vpRS.getInt(vfI+1));
                                break;
                            case Types.FLOAT:
                            case Types.DOUBLE:
                                vfBuffer = Float.toString(vpRS.getFloat(vfI+1));
                                break;
                        }
        	            vfAnswer[vfI] = vfBuffer.getBytes();
            	        if(!vpRS.wasNull())
            	            vfBitmask[vfWhichByte] |= vfWhichBit;
            	        vfWhichBit >>= 1;
            	        if (vfWhichBit == 0)
            	        {
            	            ++vfWhichByte;
            	            vfWhichBit = 0x80;
            	            vfBitmask[vfWhichByte]=0;
            	        }
        	        }
        	    }
                vcIDDBStream.SendChar('D');	// Text Data Transfer
                vcIDDBStream.Send(vfBitmask);
                vfWhichBit = 0x80;
                vfWhichByte = 0;
                for (vfI = 0 ; vfI < vpFieldCount ; ++vfI)
                {
                    if(vcFieldSiteId[vfI])
                    {
            	        boolean isNull = ((vfBitmask[vfWhichByte] & vfWhichBit) == 0);
            	        vfWhichBit >>= 1;
            	        if (vfWhichBit == 0)
            	        {
            	            ++vfWhichByte;
            	            vfWhichBit = 0x80;
            	        }
            	        if (!isNull)
            	        {
        	                if(vcDebugLevel>=1)
                                System.out.print(" | ");
            	            vcIDDBStream.SendInteger(vfAnswer[vfI].length,4);
        	                if(vcDebugLevel>=1)
                	            System.out.print(new String(vfAnswer[vfI]));
            	            vcIDDBStream.Send(vfAnswer[vfI]);
            	        }
            	    }
                }
    	        if(vcDebugLevel>=1)
            	    System.out.println(" | ");
            }
	    } catch (SQLException vfEx) {
	        vcError.fPutError(1406, "Connector Error : While send Tupels, Exception: " + vfEx.toString());
	        throw new IOException("I/O Error: " + vfEx.toString());
	    }
    }

    private int fSendFields(ResultSetMetaData vpRSMD) throws SQLException
    {
        if(vcDebugLevel>=1)
            System.out.println("Print header field : "+vcConnectorNo);
        int vfFieldCount,vfI;
        vcFieldCountMinus=0;
        vfFieldCount=vpRSMD.getColumnCount();
        vcFieldSiteId = new boolean[vfFieldCount];
        try
        {
    	    vcIDDBStream.SendChar('T');	// MetaData Field Description

            for (vfI = 1 ; vfI <= vfFieldCount ; ++vfI)
            {
                if((vcOptimizerType==IDDBConstants.OPTIMIZER_REPLICATOR)&&(vpRSMD.getColumnName(vfI).trim().equalsIgnoreCase("isiteid")))
                {
                    vcFieldSiteId[vfI-1]=false;
                    vcFieldCountMinus++;
                }
                else
                    vcFieldSiteId[vfI-1]=true;
            }

            vcIDDBStream.SendInteger(vfFieldCount-vcFieldCountMinus,4);

            for (vfI = 1 ; vfI <= vfFieldCount ; ++vfI)
            {
                if(vcFieldSiteId[vfI-1])
                {
                    if(vcDebugLevel>=1)
    	                System.out.print(" | "+vpRSMD.getColumnName(vfI));
    	            vcIDDBStream.SendString(vpRSMD.getColumnName(vfI));
                    if(vcDebugLevel>=1)
    	                System.out.print(" | "+vpRSMD.getColumnType(vfI));
    	            int vfColumnType=vpRSMD.getColumnType(vfI);
    	            vfColumnType=vfColumnType==Types.DOUBLE ? Types.FLOAT : vfColumnType;
    	            vcIDDBStream.SendInteger(vfColumnType,4);
                    if(vcDebugLevel>=1)
    	                System.out.println(" | "+vpRSMD.getPrecision(vfI)+" | ");
    	            vcIDDBStream.SendInteger(vpRSMD.getPrecision(vfI),4);
    	        }
	        }
        } catch (IOException vfEx)
        {
	        vcError.fPutError(1407, "Connector Error : While send Header of Tuples, Exception: " + vfEx.toString());
	        throw new SQLException("I/O Error: " + vfEx.toString());
        }
        return vfFieldCount;
    }

    public void fPutRSOut(ResultOut vpRSOut) throws IOException
    {
        ResultSetMetaData vfRSMD=null;
        int vfI=0;
        int vfFieldCount=0;
        for (Enumeration vfEn = vpRSOut.RS.elements() ; vfEn.hasMoreElements() ;vfI++)
        {
            ResultSet vfRS=(ResultSet) vfEn.nextElement();
            try
            {
                if(vfI==0)
                {
                    vfRSMD=vfRS.getMetaData();
                    vfFieldCount=fSendFields(vfRSMD);
                }
    	        fSendTuple(vfFieldCount, vfRS,vfRSMD);
            } catch (SQLException vfEx)
            {
	            vcError.fPutError(1408, "Connector Error : While send Result, Exception: " + vfEx.toString());
//    	        System.out.println("SQL Error: " + vfEx.toString());
            }
        }
   	    vcIDDBStream.SendChar('O');	// Ok

    }

    public void fPutRSi(int vpRSi)
    {
        try
        {
    	    vcIDDBStream.SendChar('U');	// Update Count
            vcIDDBStream.SendInteger(vpRSi,4);
    	    vcIDDBStream.SendChar('O');	// Ok
        } catch (IOException vfEx)
        {
	        vcError.fPutError(1409, "Connector Error : While send count of Updated Tuples, Exception: " + vfEx.toString());
        }
    }

    public void fPutError(String vpError)
    {
        try
        {
    	    vcIDDBStream.SendChar('E');	// Error
            vcIDDBStream.SendString(vpError);
        } catch (IOException vfEx)
        {
	        vcError.fPutError(1410, "Connector Error : While send Error, Exception: " + vfEx.toString());
        }
    }

    public void fPutWarning(String vpWarning)
    {
        try
        {
    	    vcIDDBStream.SendChar('W');	// Warning
            vcIDDBStream.SendString(vpWarning);
        } catch (IOException vfEx)
        {
	        vcError.fPutError(1411, "Connector Error : While send Warning, Exception: " + vfEx.toString());
        }
    }


    public void run()
    {
        while(!execute());
    }

    public void stop() { vcSThread.stop(); }

    public void destroy() throws IOException
    {
        this.stop();
        vcIDDBStream.close();
    }
}