import java.io.*;

class ErrorManager
{
    private int vcDebugLevel;
    private CommunicationManager vcCommunicationManager;
    IDDBStream vcIDDBStream;

    ErrorManager(int vpDebugLevel)
    {
        vcDebugLevel=vpDebugLevel;
    }

    public void fInsertCommunicationManager(CommunicationManager vpCommunicationManager)
    {
        vcCommunicationManager=vpCommunicationManager;
    }

    public void fPutError(int vpErrorCode, String vpError)
    {
        fPutError(vpErrorCode, vpError, false);
    }

    public void fPutError(int vpErrorCode, String vpError, IDDBStream vpIDDBStream)
    {
        vcIDDBStream=vpIDDBStream;
        fPutError(vpErrorCode, vpError, true);
    }

    public void fPutWarning(int vpWarningCode, String vpWarning)
    {
        fPutWarning(vpWarningCode, vpWarning, false);
    }

    public void fPutWarning(int vpWarningCode, String vpWarning, IDDBStream vpIDDBStream)
    {
        vcIDDBStream=vpIDDBStream;
        fPutWarning(vpWarningCode, vpWarning, true);
    }

    public void fPutError(int vpErrorCode, String vpError,boolean vpConnectorOut)
    {
        if (vpConnectorOut)
            vcCommunicationManager.fPutError(vpError);

        if (vcDebugLevel>=0)
        {
            System.err.println("IDDB Error ("+vpErrorCode+"): "+vpError);
        }
    }

    public void fPutWarning(int vpWarningCode, String vpWarning,boolean vpConnectorOut)
    {
        if (vpConnectorOut)
            vcCommunicationManager.fPutWarning(vpWarning);

        if (vcDebugLevel>=0)
        {
            System.out.println("IDDB Warning ("+vpWarningCode+"): "+vpWarning);
        }
    }

}