import java.sql.*;
import java.util.*;
import java.io.*;

class Executor
{
    private ErrorManager vcError;
	private int vcDebugLevel;

	private Statement vcSUpdate;
	private Statement vcSQuery;

	private Vector vcSite= new Vector();
	private Vector vcSiteList= new Vector();

    private Vector vcSiteListCurrent;

//	private Hashtable queueQuery= new Hashtable();
	private int vcQueryNo=0;

    public Hashtable vcRA= new Hashtable();

    private int vcOptimizerType=IDDBConstants.OPTIMIZER_SEMIJOIN;
	private int vcInsertCounter=0;
	private int vcInsertType=IDDBConstants.INSERT_FRAGMENT;
	private Random vcRandom = new Random();
//	private Connection vcConnection;

    public ResultOut vcRSOut;

    private String vcexecuteQueryEnd=null;

    private int vcReplicatorType = IDDBConstants.REPLICATOR_ASYN;
    private long vcReplTimeAsyn = 10000;
    private Replicator vcRepl;

    private boolean vcPutRALock=true;

    private Vector vcTableDropList;

    public Executor(Connection vpConnection, int vpInsertType, int vpOptimizerType,
        int vpReplicatorType, long vpReplTimeAsyn, ErrorManager vpError, int vpDebugLevel)
    {
        vcError=vpError;
        vcDebugLevel=vpDebugLevel;
        vcInsertType=vpInsertType;
        vcOptimizerType=vpOptimizerType;
        vcReplicatorType=vpReplicatorType;
        vcReplTimeAsyn=vpReplTimeAsyn;


        try
        {
      		vcSUpdate = vpConnection.createStatement();
      		vcSQuery = vcSUpdate;
//      		vcConnection=vpConnection;
//      		vcSQuery = vpConnection.createStatement();
	    } catch (SQLException vfEx) {
		    vcError.fPutError(1701,"Executor Error : Initialisation failed, Exception: " + vfEx.toString());
	    }
        fInitRA();

        if(vcReplicatorType!=IDDBConstants.REPLICATOR_NONE)
        {
            vcRepl= new Replicator(vcReplTimeAsyn,this,vpConnection, vpError, vpDebugLevel);
            if(vcReplicatorType==IDDBConstants.REPLICATOR_ASYN)
            {
                vcRepl.start();
                vcRepl.vcLock=false;
            }
        }
    }

    public void close()
    {
        fCloseRA();
		try
		{
      	    vcSUpdate.close();
//      	    vcSQuery.close();
		} catch (SQLException vfEx) {
		    vcError.fPutError(1702,"Executor Error : Close failed, Exception: " + vfEx.toString());
		}
		vcRepl.close();
    }

    private void fPutRAWait()
    {
        vcPutRALock=true;
//            System.out.println("IN tunggu RA");
            int I=0;
        while(vcPutRALock) I++;
//            System.out.println("OUT tunggu RA : "+I);
    }

    private void fPutRA(String vpQuery,int vpCommand,Vector vpSiteList)
    {
        vcSiteListCurrent=vpSiteList;
//            System.out.println("IN fPutRA");
        vcRSOut=new ResultOut();
        Integer vfQueryNo=new Integer(vcQueryNo++);
        for (Enumeration vfEn = vpSiteList.elements() ; vfEn.hasMoreElements() ;)
        {
            String vfSiteId = (String) vfEn.nextElement();
            ((RemoteAgent)vcRA.get(vfSiteId)).put(vfQueryNo,vpQuery,vpCommand==IDDBConstants.COMMAND_SELECT);
        }
        fPutRAWait();
//            System.out.println("OUT fPutRA");

    }


    void fPutRASingle(String vpQuery,int vpCommand,String vpSiteId)
    {
//            System.out.println("IN fPutRASingle");
        vcRSOut=new ResultOut();
        vcSiteListCurrent=new Vector();
        vcSiteListCurrent.addElement(vpSiteId);

        Integer vfQueryNo=new Integer(vcQueryNo++);
        ((RemoteAgent)vcRA.get(vpSiteId)).put(vfQueryNo,vpQuery,vpCommand==IDDBConstants.COMMAND_SELECT);

        fPutRAWait();
//            System.out.println("OUT fPutRASingle");

    }

    private void fCommandCreateTable(parserout_t vpPO) throws SQLException
    {
        tname_t vfTName=(tname_t) vpPO.table.elements().nextElement();
        ResultSet vfRS=vcSQuery.executeQuery("select * from iddbtb where itbname = '"+vfTName.name+"'");
        if((vfRS!=null)&&vfRS.next())
        {
            vcError.fPutError(1703,"Executor Error: Table : "+vfTName.name+" exist",true);
            return;
        }
        String vfQuery="insert into iddbtb values( '"+vfTName.name+"' ,'"+vpPO.vcUser+"' )";

        if(vcDebugLevel>=1)
            System.out.println(vfQuery);
        vcSUpdate.executeUpdate(vfQuery);


        String vfQueryTmp="";
        int vfNo=0;
        for (Enumeration vfEn = vpPO.field.elements() ; vfEn.hasMoreElements() ;)
        {
            field_t vfField=(field_t) vfEn.nextElement();
            int vfPKF=(vfField.primarykeyflag ? 1 : 0);
            int vfNNF=(vfField.notnullflag ? 1 : 0);
            vfQuery="insert into iddbtbfield values('"+vfTName.name+"' ,'"+vfField.name+"' ,"+
            vfField.type+" ,"+vfField.length+" ,"+vfNNF+" ,"+vfPKF+", "+vfNo++ +")";

	        if(vcDebugLevel>=1)
                System.out.println(vfQuery);

            vcSUpdate.executeUpdate(vfQuery);

            if(!vfQueryTmp.equals(""))
                vfQueryTmp+=", ";
            vfQueryTmp+=vfField.name+ " ";
            switch (vfField.type)
            {
                case Types.CHAR:
                    vfQueryTmp+="char("+vfField.length+")";
                    break;
                case Types.INTEGER:
                    vfQueryTmp+="integer";
                    break;
                case Types.FLOAT:
                    vfQueryTmp+="float";
                    break;
            }

        }

        vcSUpdate.executeUpdate("insert into iddbtbcount values('"+vfTName.name+"','*',0)");

        // buat table & log replikasi baru
        if(vcReplicatorType!=IDDBConstants.REPLICATOR_NONE)
        {
            vcSUpdate.executeUpdate("create table "+ vfTName.name +"("+vfQueryTmp+", isiteid char(20))");
            vcSUpdate.executeUpdate("create table log"+vfTName.name+" (idate char(40) not null, icounter integer not null,"+
                "ioperation char(250), itype integer, iuser char(20), isiteid char(20))");
        }
        vcRSOut= new ResultOut();
        vcRSOut.RSi=1;
	}

    private void fCommandDropTable(parserout_t vpPO)throws SQLException
    {
        tname_t vfTName=(tname_t) vpPO.table.elements().nextElement();

        // cek apakah ada table itu
        ResultSet vfRS=vcSQuery.executeQuery("select * from iddbtb where itbname = '"+vfTName.name+"'");
        if((vfRS==null)||!vfRS.next())
        {

            vcError.fPutError(1704,"Executor Error : Table: "+vfTName.name+" not exist",true);
            return;
        }
        if(vpPO.vcUserLevel==IDDBConstants.USER_LEVEL_ROOT)
        {
            String vfUser=vfRS.getString(2);
            vfRS=vcSQuery.executeQuery("select ilevel from iddbuser where iuser = '"+vfUser+"'");
            vfRS.next();
            int vfUserLevel=vfRS.getInt(1);

            if((vfUserLevel==vpPO.vcUserLevel)&& !vfUser.equals(vpPO.vcUser))
            {
                vcError.fPutError(1705,"Executor Error : User "+vpPO.vcUser+" level ROOT is not the owner of table",true);
                return;
            }
        }

        vcSUpdate.executeUpdate("delete from iddbtb where itbname = '"+vfTName.name+"'");
        vcSUpdate.executeUpdate("delete from iddbtbfield where itbname = '"+vfTName.name+"'");
        vcSUpdate.executeUpdate("delete from iddbtbsite where itbname = '"+vfTName.name+"'");
        if(vcReplicatorType!=IDDBConstants.REPLICATOR_NONE)
        {
            vcSUpdate.executeUpdate("drop table "+vfTName.name );
            vcSUpdate.executeUpdate("drop table log"+vfTName.name );
            vcSUpdate.executeUpdate("delete from iddbtbcount where itbname='"+vfTName.name+"'");
        }
        vcRSOut.RSi=1;
    }

    private void fCommandInsert(parserout_t vpPO) throws SQLException
    {
        // get table name
        tname_t vfTName = (tname_t) vpPO.table.elements().nextElement();

        // cek apakah ada table itu
        ResultSet vfRS=vcSQuery.executeQuery("select * from iddbtbfield where itbname = '"+vfTName.name+"'");
        if((vfRS==null)||!vfRS.next())
        {
            vcError.fPutError(1704,"Executor Error : Table: "+vfTName.name+" not exist",true);
            return;
        }

        Hashtable vfFieldList= new Hashtable();
        Enumeration vfEn = vpPO.field.elements();

        // ambil field dari iddbtbfield
        do {
            if(!vfEn.hasMoreElements())
            {
                vcError.fPutError(1706,"Executor Error : Count of field not same with structur field of table in 'iddbtbfield'",true);
                return;
            }
            field_t vfPOF = (field_t) vfEn.nextElement();
            field_t vfF= new field_t();
            vfF.name=vfRS.getString(2).trim();
            vfF.type=vfRS.getInt(3);
            vfF.length=vfRS.getInt(4);
            vfF.value=vfPOF.value;
            vfF.notnullflag = vfRS.getInt(5)==1?true:false;
            vfF.primarykeyflag = vfRS.getInt(6)==1?true:false;
            vfFieldList.put(vfF.name,vfF);
        }while(vfRS.next());

        // cek apakah ada yang sesuai dengan aturan fragmentasi
        // jika ada yang sesuai yang ditemui pertama dalam daftar aturan fragmentasi itu yang
        // di masukkan, kalau tidak ada dimasukkan ke default.
        vfRS = vcSQuery.executeQuery("select * from iddbtbsite where itbname = '"+vfTName.name+"'");
        //jika tidak ada ke default
        // for selama masih siteid yang sama state belum berganti
        // cek syarat.
        // benar= false.
        String vfSiteId="",vfSiteIdDefault=null;
        boolean vfCond=true,vfFound=false;
        int vfCounter=0;
        Vector vfRA = new Vector();
        while(vfRS.next())
        {
            String vfSiteIdTmp=vfRS.getString(2).trim();
            if(vfSiteId.equals(vfSiteIdTmp))
            {
                vfCounter++;
            }else
            {
                if(vfFound)
                    break;
                vfCounter=0;
                vfSiteId=vfSiteIdTmp;
//                if(vfSiteIdDefault==null)
//                    vfSiteIdDefault=vfSiteIdTmp;
                vfEn=vpPO.cond.elements();
                vfRA.addElement(vfSiteId);
            }
            if(vfRS.getInt(10)==1)
                vfSiteIdDefault=vfSiteIdTmp;

            if(vcInsertType==IDDBConstants.INSERT_FRAGMENT)
            {
                //cari urutan field yang sesuai
                field_t vfField=(field_t)vfFieldList.get(vfRS.getString(3).trim());

                boolean vfExp=true;
                switch(vfRS.getInt(8))
                {
                    case IDDBConstants.EQ_OP:
                        switch(vfField.type)
                        {
                            case Types.INTEGER:
                                vfExp= vfField.value.intVal== vfRS.getInt(5);
                                break;
                            case Types.FLOAT:
                                vfExp= vfField.value.floatVal== vfRS.getFloat(6);
                                break;
                            case Types.CHAR:
                                vfExp= vfField.value.charVal.compareTo("'"+vfRS.getString(7).trim()+"'")==0;
                                break;
                        }
                        break;
                    case IDDBConstants.LT_OP:
                        switch(vfField.type)
                        {
                            case Types.INTEGER:
                                vfExp= vfField.value.intVal < vfRS.getInt(5);
                                break;
                            case Types.FLOAT:
                                vfExp= vfField.value.floatVal < vfRS.getFloat(6);
                                break;
                            case Types.CHAR:
                                vfExp= vfField.value.charVal.compareTo("'"+vfRS.getString(7)+"'")<0;
                                break;
                        }
                        break;
                    case IDDBConstants.GT_OP:
                        switch(vfField.type)
                        {
                            case Types.INTEGER:
                                vfExp= vfField.value.intVal > vfRS.getInt(5);
                                break;
                            case Types.FLOAT:
                                vfExp= vfField.value.floatVal > vfRS.getFloat(6);
                                break;
                            case Types.CHAR:
                                vfExp= vfField.value.charVal.compareTo("'"+vfRS.getString(7)+"'")>0;
                                break;
                        }
                        break;
                    case IDDBConstants.NE_OP:
                        switch(vfField.type)
                        {
                            case Types.INTEGER:
                                vfExp= vfField.value.intVal != vfRS.getInt(5);
                                break;
                            case Types.FLOAT:
                                vfExp= vfField.value.floatVal != vfRS.getFloat(6);
                                break;
                            case Types.CHAR:
                                vfExp= vfField.value.charVal.compareTo("'"+vfRS.getString(7)+"'")!=0;
                                break;
                        }
                        break;
                    case IDDBConstants.LE_OP:
                        switch(vfField.type)
                        {
                            case Types.INTEGER:
                                vfExp= vfField.value.intVal <= vfRS.getInt(5);
                                break;
                            case Types.FLOAT:
                                vfExp= vfField.value.floatVal <= vfRS.getFloat(6);
                                break;
                            case Types.CHAR:
                                vfExp= vfField.value.charVal.compareTo("'"+vfRS.getString(7)+"'")<=0;
                                break;
                        }
                        break;
                    case IDDBConstants.GE_OP:
                        switch(vfField.type)
                        {
                            case Types.INTEGER:
                                vfExp= vfField.value.intVal >= vfRS.getInt(5);
                                break;
                            case Types.FLOAT:
                                vfExp= vfField.value.floatVal >= vfRS.getFloat(6);
                                break;
                            case Types.CHAR:
                                vfExp= vfField.value.charVal.compareTo("'"+vfRS.getString(7)+"'")>=0;
                                break;
                        }
                        break;
                }

                switch(vfRS.getInt(9))
                {
                    case IDDBConstants.NO_BOOL:
                        vfFound=vfExp;
                        break;
                    case IDDBConstants.AND_BOOL:
                        vfFound=vfFound && vfExp;
                        break;
                    case IDDBConstants.OR_BOOL:
                        vfFound=vfFound || vfExp;
                        break;
                }
            }
        }

        // satukan hasil
        String vfQueryInsert="insert into "+vfTName.name+" values (";
        int vfI=0;
        vfEn = vpPO.field.elements();
        for(;vfEn.hasMoreElements() ;vfI++)
        {
            if(vfI!=0)
                vfQueryInsert+=", ";
            field_t vfF = (field_t)vfEn.nextElement();
            switch(vfF.value.type)
            {
                case IDDBConstants.INT_TYPE :
                    vfQueryInsert += vfF.value.intVal;
                    break;
                case IDDBConstants.FLOAT_TYPE	:
                    vfQueryInsert += vfF.value.floatVal;
                    break;
                case IDDBConstants.CHAR_TYPE :
                    vfQueryInsert += vfF.value.charVal;
                    break;
            }
        }
        String vfQueryReplication=vfQueryInsert;
        vfQueryInsert+=")";

        switch(vcInsertType)
        {
            case IDDBConstants.INSERT_RANDOM:
                int vfIndex=Math.abs(vcRandom.nextInt()) % vfRA.size();
//                System.out.println("Index : "+vfIndex+" vfRA.size() : "+vfRA.size());
                vfSiteId=(String)vfRA.elementAt(vfIndex);
                break;
            case IDDBConstants.INSERT_ORDER:
                vcInsertCounter= ++vcInsertCounter % vfRA.size();
                vfSiteId=(String)vfRA.elementAt(vcInsertCounter);
                break;
            case IDDBConstants.INSERT_FRAGMENT:
                if(!vfFound)
                    if(vfSiteIdDefault==null)
                    {
                        vcError.fPutError(1716,"Executor Error : Table: "+vfTName.name+" not found which site DEFAULT to be inserted",true);
                        return;
                    }
                    else
                        vfSiteId=vfSiteIdDefault;
                break;
        }


        fPutRASingle("select icounter from iddbtbcount"+
        " where itbname = '"+vfTName.name+"'",IDDBConstants.COMMAND_SELECT,vfSiteId);

        vfRS = (ResultSet) vcRSOut.RS.elementAt(0);
//        System.out.println("dilewati!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
        vfRS.next();
        int vfTbCount=vfRS.getInt(1);

        String vfQueryLogRA="insert into log"+vfTName.name+" values('"+
            (new java.util.Date(System.currentTimeMillis())).toString()+
            "',"+vfTbCount +",'"+Tools.fReplaceString(vfQueryInsert,"'","''")+"',"+
            IDDBConstants.COMMAND_INSERT+",'"+vpPO.vcUser+"'";
        String vfQueryLog=vfQueryLogRA;
        vfQueryLogRA+=",'"+vfSiteId+"')";

        // masukkan dalam RA data & log
        fPutRASingle(vfQueryInsert,IDDBConstants.COMMAND_INSERT,vfSiteId);
        fPutRASingle(vfQueryLogRA,IDDBConstants.COMMAND_INSERT,vfSiteId);

        fPutRASingle("update iddbtbcount set icounter = "+ ++vfTbCount +
        " where itbname = '"+vfTName.name+"'",IDDBConstants.COMMAND_INSERT,vfSiteId);

        // masukkan dalam data & log replication
        if(vcReplicatorType==IDDBConstants.REPLICATOR_SYN)
        {
/*            vfQueryLog+=",'"+vfSiteId+"')";
            vfQueryReplication+=",'"+vfSiteId+"')";
*/

            vcRepl.fReplication();

/*            vcSUpdate.executeUpdate("update iddbtbcount set icounter = "+ vfTbCount +
            " where itbname = '"+vfTName.name+"' and isiteid = '"+vfSiteId+"'");
            vcSUpdate.executeUpdate(vfQueryLog);
            vcSUpdate.executeUpdate(vfQueryReplication);
*/      }

    }

    private void fCommandDelete(parserout_t vpPO) throws SQLException
    {

        // ambil table
        tname_t vfTName = (tname_t) vpPO.table.elements().nextElement();

        // cek apakah ada table itu
        ResultSet vfRS=vcSQuery.executeQuery("select * from iddbtb where itbname = '"+vfTName.name+"'");
        if((vfRS==null)||!vfRS.next())
        {
            vcError.fPutError(1704,"Executor Error : Table: "+vfTName.name+" not exist",true);
            return;
        }

        // ambil isiteid dari table iddbtbsite
        vfRS=vcSQuery.executeQuery("select isiteid from iddbtbsite where itbname = '"+vfTName.name+"'");
        Vector vfRA=new Vector();
        while(vfRS.next())
        {
            vfRA.addElement(vfRS.getString(1).trim());
        }

        // gabungkan semua string
        String vfQueryDelete="delete from "+vfTName.name+" where ";
        int vfI=0;
        for (Enumeration vfEn = vpPO.cond.elements() ; vfEn.hasMoreElements() ;vfI++)
        {
            cond_t vfCond= (cond_t)vfEn.nextElement();
            if(vfI!=0)
            {
                switch(vfCond.op)
                {
                    case IDDBConstants.AND_BOOL:
                        vfQueryDelete+=" and ";
                        break;
                    case IDDBConstants.OR_BOOL:
                        vfQueryDelete+=" or ";
                        break;
                }
            }
            vfQueryDelete+=" "+vfCond.name+Tools.fOp(vfCond.op)+Tools.fValue(vfCond.value);
        }

        if(vcDebugLevel>=1)
            System.out.println(vfQueryDelete);

        // lempar ke semua table RA
        if(vcInsertType==IDDBConstants.INSERT_FRAGMENT)
            fPutRA(vfQueryDelete,IDDBConstants.COMMAND_DELETE,(Vector)vfRA.clone());
        else
            fPutRA(vfQueryDelete,IDDBConstants.COMMAND_DELETE,(Vector)vcSiteList.clone());

        vfRS =vcSQuery.executeQuery("select icounter from iddbtbcount"+
        " where itbname = '"+vfTName.name+"' and isiteid = '*'");
        vfRS.next();
        int vfTbCount=vfRS.getInt(1);
        String vfQueryLogRA="insert into log"+vfTName.name+" values('"+
            (new java.util.Date(System.currentTimeMillis())).toString()+
            "',"+vfTbCount +",'"+Tools.fReplaceString(vfQueryDelete,"'","''")+"',"+
            IDDBConstants.COMMAND_DELETE+",'"+vpPO.vcUser+"'";
        String vfQueryLog=vfQueryLogRA+",'*')";
        vfQueryLogRA+=",'*')";

        if(vcInsertType==IDDBConstants.INSERT_FRAGMENT)
            fPutRA(vfQueryLogRA,IDDBConstants.COMMAND_INSERT,(Vector)vfRA.clone());
        else
            fPutRA(vfQueryLogRA,IDDBConstants.COMMAND_INSERT,(Vector)vcSiteList.clone());
        vcSUpdate.executeUpdate("update iddbtbcount set icounter = "+ ++vfTbCount +
        " where itbname = '"+vfTName.name+"' and isiteid = '*'");

        // masukkan dalam data & log replication
        if(vcReplicatorType!=IDDBConstants.REPLICATOR_NONE)
        {
            vcSUpdate.executeUpdate(vfQueryLog);
            vcSUpdate.executeUpdate(vfQueryDelete);
        }
    }

    private void fCommandUpdate(parserout_t vpPO) throws SQLException
    {
        // ambil table
        tname_t vfTName = (tname_t) vpPO.table.elements().nextElement();

        // cek apakah ada table itu
        ResultSet vfRS=vcSQuery.executeQuery("select * from iddbtb where itbname = '"+vfTName.name+"'");
        if((vfRS==null)||!vfRS.next())
        {
            vcError.fPutError(1704,"Executor Error : Table: "+vfTName.name+" not exist",true);
            return;
        }

        // ambil isiteid dari table iddbtbsite
        vfRS=vcSQuery.executeQuery("select isiteid from iddbtbsite where itbname = '"+vfTName.name+"'");
        Vector vfRA=new Vector();
        while(vfRS.next())
        {
            vfRA.addElement(vfRS.getString(1).trim());
        }

        // cek apakah tidak ada yang melanggar setiap aturan fragmentasi yang ada
        // jika ada keluarkan error
        // jika tidak ada lempar ke semua RA

        vfRS = vcSQuery.executeQuery("select ifname from iddbtbsite where itbname = '"+vfTName.name+"'");
        while(vfRS.next())
        {
            String vfRSg=vfRS.getString(1).trim();
            for (Enumeration vfEn = vpPO.field.elements() ; vfEn.hasMoreElements() ;)
            {
                field_t vfF= (field_t)vfEn.nextElement();
                if(vfF.name.equals(vfRSg))
                {
                    vcError.fPutError(1707,"Executor Error : field: "+vfRSg+" have fragmentation rule will not be changed",true);
                    return;
                }
            }
        }

        String vfQueryUpdate = "update "+vfTName.name+" set ";

        // satukan set field
        int vfI=0;
        for (Enumeration vfEn = vpPO.field.elements() ; vfEn.hasMoreElements() ;vfI++)
        {
            field_t vfF= (field_t)vfEn.nextElement();
            if(vfI!=0)
                vfQueryUpdate+=", ";
            vfQueryUpdate+=" "+vfF.name+" = "+Tools.fValue(vfF.value);
        }


        // satukan condition
        vfQueryUpdate += " where ";
        vfI=0;
        for (Enumeration vfEn = vpPO.cond.elements() ; vfEn.hasMoreElements() ;vfI++)
        {
            cond_t vfCond= (cond_t)vfEn.nextElement();
            if(vfI!=0)
            {
                switch(vfCond.op)
                {
                    case IDDBConstants.AND_BOOL:
                        vfQueryUpdate+=" and ";
                        break;
                    case IDDBConstants.OR_BOOL:
                        vfQueryUpdate+=" or ";
                        break;
                }
            }
            vfQueryUpdate+=" "+vfCond.name+Tools.fOp(vfCond.op)+Tools.fValue(vfCond.value);
        }



        if(vcDebugLevel>=1)
            System.out.println(vfQueryUpdate);

        // lempar ke semua RA
        if(vcInsertType==IDDBConstants.INSERT_FRAGMENT)
            fPutRA(vfQueryUpdate,IDDBConstants.COMMAND_UPDATE,(Vector)vfRA.clone());
        else
            fPutRA(vfQueryUpdate,IDDBConstants.COMMAND_UPDATE,(Vector)vcSiteList.clone());

        vfRS =vcSQuery.executeQuery("select icounter from iddbtbcount"+
        " where itbname = '"+vfTName.name+"' and isiteid = '*'");
        vfRS.next();
        int vfTbCount=vfRS.getInt(1);

        // masukkan log
        String vfQueryLogRA="insert into log"+vfTName.name+" values('"+
            (new java.util.Date(System.currentTimeMillis())).toString()+
            "',"+vfTbCount +",'"+Tools.fReplaceString(vfQueryUpdate,"'","''")+"',"+
            IDDBConstants.COMMAND_UPDATE+",'"+vpPO.vcUser+"'";
        String vfQueryLog=vfQueryLogRA+",'*')";
        vfQueryLogRA+=",'*')";

        if(vcInsertType==IDDBConstants.INSERT_FRAGMENT)
            fPutRA(vfQueryLogRA,IDDBConstants.COMMAND_INSERT,(Vector)vfRA.clone());
        else
            fPutRA(vfQueryLogRA,IDDBConstants.COMMAND_INSERT,(Vector)vcSiteList.clone());
        vcSUpdate.executeUpdate("update iddbtbcount set icounter = "+ ++vfTbCount +
        " where itbname = '"+vfTName.name+"' and isiteid = '*'");

        // masukkan dalam data & log replication
        if(vcReplicatorType!=IDDBConstants.REPLICATOR_NONE)
        {
            vcSUpdate.executeUpdate(vfQueryLog);
            vcSUpdate.executeUpdate(vfQueryUpdate);
        }
    }

    private void fCommandSelect(parserout_t vpPO,Vector ScheduleList)
    {
        if(vcReplicatorType==IDDBConstants.REPLICATOR_SYN)
            vcRepl.fReplication();
        switch(vcOptimizerType)
        {
            case IDDBConstants.OPTIMIZER_REPLICATOR:
            case IDDBConstants.OPTIMIZER_DIRECT:
            // ambil table
            for(Enumeration vfEn = vpPO.table.elements() ; vfEn.hasMoreElements() ;)
            {
                tname_t vfTName = (tname_t) vfEn.nextElement();

                // cek apakah ada table itu
                try
                {
                    ResultSet vfRS=vcSQuery.executeQuery("select * from iddbtb where itbname = '"+vfTName.name+"'");
                    if((vfRS==null)||!vfRS.next())
                    {
                        vcError.fPutError(1704,"Executor Error : Table: "+vfTName.name+" not exist",true);
                        return;
                    }
                    break;
                } catch (SQLException vfEx) {
            	    System.out.println("Exception: " + vfEx.toString());
            	}
        	}
        }
        try
        {
            switch(vcOptimizerType)
            {
                case IDDBConstants.OPTIMIZER_REPLICATOR:
                    vcRSOut=new ResultOut();
                    vcRSOut.RS.addElement(vcSQuery.executeQuery(vpPO.query));
                    break;
                case IDDBConstants.OPTIMIZER_DIRECT:
// hanya bisa dilakukan jika jumlah dan struktur tabel di tiap-tiap site sama, dan tiap-tiap tabel terfragmentasi horisontal secara local
                    fPutRA(vpPO.query,IDDBConstants.COMMAND_SELECT,(Vector) vcSiteList.clone());
                    break;
                case IDDBConstants.OPTIMIZER_SEMIJOIN:
                    vcTableDropList=new Vector();
                    ResultSet vfRSSelect=null;
                    for (Enumeration vfEn = ScheduleList.elements() ; vfEn.hasMoreElements();)
                    {
                        schedule_t vfSchedule = (schedule_t)vfEn.nextElement();
                        if(vcDebugLevel>=1)
                            System.out.println(vfSchedule.query);
                        if(vfSchedule.command!=IDDBConstants.COMMAND_INSERT)
                        {
                            if(vfSchedule.RA)
                            {
                                if(vfSchedule.command==IDDBConstants.COMMAND_SELECT)
                                {
                                    String vfSchSelectRA = vfSchedule.query;
        //                            Vector vfSiteList = (Vector)vcSiteList.clone();
                                    vfSchedule = (schedule_t)vfEn.nextElement();
                                    for(Enumeration vfEn2 = vfSchedule.site.elements() ; vfEn2.hasMoreElements() ;)
                                    {
                                        Vector vfQInsertRAList = new Vector();
                                        Vector vfQInsertList = new Vector();
                                        String vfSiteId = (String) vfEn2.nextElement();

                                        fPutRASingle(vfSchSelectRA,IDDBConstants.COMMAND_SELECT,vfSiteId);
                                        ResultSet vfRS=(ResultSet) vcRSOut.RS.elementAt(0);
        //                                vcRSOut.RS.removeElementAt(0);

                                        while(vfRS.next())
                                        {

                                            String vfQueryInsert="";
                                            String vfQueryInsertRA="";
                                            int vfI=1;
                                            for(Enumeration vfEn3 = vfSchedule.field.elements() ; vfEn3.hasMoreElements() ;vfI++)
                                            {
                                    	        field_t vfF=(field_t)vfEn3.nextElement();
                                                if(!vfQueryInsert.equals(""))
                                                    vfQueryInsert+=", ";
                                                String vfStr="";
                                                switch (vfF.type)
                                                {
                                                    case Types.CHAR:
                                                        vfStr="'"+vfRS.getString(vfI)+"'";
                                                        break;
                                                    case Types.INTEGER:
                                                        vfStr=""+vfRS.getInt(vfI);
                                                        break;
                                                    case Types.DOUBLE:
                                                    case Types.FLOAT:
                                                        vfStr=""+vfRS.getFloat(vfI);
                                                        break;
                                                }
                                                vfQueryInsert+=vfStr;
                                                if (vfF.condJoin)
                                                {
                                                    if(!vfQueryInsertRA.equals(""))
                                                        vfQueryInsertRA+=", ";
                                                    vfQueryInsertRA+=vfStr;
                                                }
                                            }

                                            vfQueryInsertRA="insert into "+vfSchedule.query+" values ("+vfQueryInsertRA+")";
                                            vfQueryInsert="insert into "+vfSchedule.query+" values ("+vfQueryInsert+")";

                                            vfQInsertRAList.addElement(vfQueryInsertRA);
                                            vfQInsertList.addElement(vfQueryInsert);
                                        }
                                        Enumeration vfEn3 = vfQInsertRAList.elements();
                                        for(Enumeration vfEn4 = vfQInsertList.elements() ; vfEn4.hasMoreElements() ;)
                                        {
                                            String vfQueryInsertRA=(String) vfEn3.nextElement();
                                            String vfQueryInsert=(String) vfEn4.nextElement();
                                            if(vfSchedule.RA)
                                            {
/*                                                if(vcInsertType==IDDBConstants.INSERT_FRAGMENT)
                                                    fPutRA(vfQueryInsertRA,vfSchedule.command,(Vector)vfSchedule.site.clone());
                                                else
*/                                                    fPutRA(vfQueryInsertRA,vfSchedule.command,(Vector)vcSiteList.clone());
                                            }

                                            if(vcDebugLevel>=1)
                                                System.out.println(vfQueryInsert);
                                            vcSUpdate.executeUpdate(vfQueryInsert);
                                        }
                                    }
                                }
                                else
                                {
/*                                    if(vcInsertType==IDDBConstants.INSERT_FRAGMENT)
                                        fPutRA(vfSchedule.query,vfSchedule.command,(Vector)vfSchedule.site.clone());
                                    else
*/                                        fPutRA(vfSchedule.query,vfSchedule.command,(Vector)vcSiteList.clone());
                                    if(vcDebugLevel>=1)
                	                    System.out.println("****----- keluar dari fPutRA");
                                }
                            }
                            else
                            {
                                if(vfSchedule.command==IDDBConstants.COMMAND_SELECT)
                                {
                                    if(vcDebugLevel>=1)
                                        System.out.println(vfSchedule.query);

                                    try
                                    {
      		                           // vcSQuery = vcConnection.createStatement();
                                        vfRSSelect=vcSQuery.executeQuery(vfSchedule.query);
                                    } catch (SQLException vfEx)
                                    {
                	                    System.out.println("Exception: " + vfEx.toString());
//                                        System.out.println("wah error lagi ");
                                    }

                                }
                                else
                                {
                                    try
                                    {
                                        if(vfSchedule.command==IDDBConstants.COMMAND_DROP_TABLE)
                                            vcTableDropList.addElement(vfSchedule.query);
                                        else
                                        {
                                            if(vcDebugLevel>=1)
                                                System.out.println(vfSchedule.query);
                                            vcSUpdate.executeUpdate(vfSchedule.query);
                                        }
                                    } catch (SQLException vfEx)
                                    {
                	                    System.out.println("******** Exception: " + vfEx.toString());
                                    }
                                }
                            }
                        }
                    }
                    vcRSOut=new ResultOut();
                    vcRSOut.RS.addElement(vfRSSelect);
                    break;
            }
        } catch (SQLException vfEx)
        {
            System.out.println("Exception: " + vfEx.toString());
    	}
    }

   void fExecuteQueryEnd()
   {
        if((vcOptimizerType==IDDBConstants.OPTIMIZER_SEMIJOIN))
        {
            try {
                    for (Enumeration vfEn = vcTableDropList.elements() ; vfEn.hasMoreElements();)
                    {
                        String vfQuery=(String) vfEn.nextElement();
                        if(vcDebugLevel>=1)
                            System.out.println(vfQuery);
                        vcSQuery.executeUpdate(vfQuery);
                    }
                    vcTableDropList=null;
            } catch (SQLException vfEx) {
                System.out.println("Exception: " + vfEx.toString());
        	}
    	}
   }

    private void fCommandExtTableCreate(parserout_t vpPO)  throws SQLException
    {
        tname_t vfTName = (tname_t) vpPO.table.elements().nextElement();

        // cek apakah ada table itu, kalau tidak ada tampilkan error
        ResultSet vfRS=vcSQuery.executeQuery("select * from iddbtb where itbname = '"+vfTName.name+"'");
        if((vfRS==null)||!vfRS.next())
        {
            vcError.fPutError(1704,"Executor Error : Table: "+vfTName.name+" not exist",true);
            return;
        }

        // cek apakah ada siteid itu, kalau tidak ada tampilkan error
        vfRS=vcSQuery.executeQuery("select * from iddbsite where isiteid = '"+vpPO.siteid+"'");
        if((vfRS==null)||!vfRS.next())
        {
            vcError.fPutError(1708,"Executor Error : Siteid: "+vpPO.siteid+" not exist",true);
            return;
        }

        // cek apakah sudah pernah ada table siteid itu, kalau ada tampilkan error
        vfRS=vcSQuery.executeQuery("select * from iddbtbsite where itbname = '"+vfTName.name+"' and isiteid = '"+vpPO.siteid+"'");
        if((vfRS!=null)&&vfRS.next())
        {
            vcError.fPutError(1709,"Executor Error : Siteid: "+vpPO.siteid+" ever exist",true);
            return;
        }

        int vfDefault=0;

        // cek apakah ada fragmentasi yang sama kalau ya error
        // cek apakah ada yang jadi default kalau ada update/hilangkan default fragmentasi
        if(vpPO.sdefault)
        {
            vfRS=vcSQuery.executeQuery("select * from iddbtbsite where itbname = '"+vfTName.name+"' and ifdefault = 1");
            if((vfRS!=null)&&vfRS.next())
            {
                vcSUpdate.executeUpdate("update iddbtbsite set ifdefault = 0 where itbname = '"+vfTName.name+"' and ifdefault = 1");
            }
            vfDefault=1;
        }

        Hashtable vfField=new Hashtable();
        // masukkan ke vector semua.
        vfRS=vcSQuery.executeQuery("select * from iddbtbfield where itbname = '"+vfTName.name+"' order by ino");
        while(vfRS.next())
        {
        	field_t vfF=new field_t();
        	vfF.table=vfRS.getString(1);
        	vfF.name=vfRS.getString(2).trim();
        	vfF.type=vfRS.getInt(3);
        	vfF.length=vfRS.getInt(4);

        	vfF.notnullflag=(vfRS.getInt(5)==1 ? true : false);
        	vfF.primarykeyflag=(vfRS.getInt(6)==1 ? true : false);
        	vfField.put(vfF.name,vfF);
        }

        //insert iddbtbsite
        if(vpPO.sdefault)
        {
            vcSUpdate.executeUpdate("insert into iddbtbsite values ( '"+vfTName.name+"', '"+vpPO.siteid+"', '', 0, 0, 0, '', 0, 0, "+vfDefault+")");
        }
        else
            for(Enumeration vfEn = vpPO.cond.elements();vfEn.hasMoreElements() ;)
            {
                cond_t vfCond = (cond_t)vfEn.nextElement();

                if(!vfField.containsKey(vfCond.name))
                {
                    vcError.fPutError(1710,"Executor Error : Field: "+vfCond.name+" not found",true);
                    return;
                }
                    ;
        	    String vfQuery1=null;

                switch(vfCond.value.type)
                {
                    case IDDBConstants.INT_TYPE :
                        vfQuery1 = vfCond.value.intVal+", "+0.0+", "+"''";
                        break;
                    case IDDBConstants.FLOAT_TYPE	:
                        vfQuery1 = 0+", "+vfCond.value.floatVal+", "+"''";
                        break;
                    case IDDBConstants.CHAR_TYPE :
                        vfQuery1 = 0+", "+0.0+", "+vfCond.value.charVal;
                        break;
                }
                vcSUpdate.executeUpdate("insert into iddbtbsite values ( '"+vfTName.name+"', '"+vpPO.siteid+"', '"+vfCond.name+"', "+vfCond.value.type+", "+vfQuery1+", "+vfCond.op+", "+vfCond.bool+", "+vfDefault+")");
            }
        //buat table di remote agent
        String vfQuery="create table "+vfTName.name+" (";
        vfRS=vcSQuery.executeQuery("select * from iddbtbfield where itbname = '"+vfTName.name+"' order by ino");
        String vfQueryTmp="";
        while(vfRS.next())
        {
            if(!vfQueryTmp.equals(""))
                vfQueryTmp+=", ";
            vfQueryTmp+=vfRS.getString(2)+ " ";
            switch (vfRS.getInt(3))
            {
                case Types.CHAR:
                    vfQueryTmp+="char("+vfRS.getInt(4)+")";
                    break;
                case Types.INTEGER:
                    vfQueryTmp+="integer";
                    break;
                case Types.FLOAT:
                    vfQueryTmp+="float";
                    break;
            }
        }
        vfQuery+=vfQueryTmp+")";

        fPutRASingle(vfQuery,IDDBConstants.COMMAND_CREATE_TABLE,vpPO.siteid);

        // create table log
        vfQuery="create table log"+vfTName.name+" (idate char(40) not null, icounter integer not null,"+
            "ioperation char(250), itype integer, iuser char(20), isiteid char(20))";

        fPutRASingle(vfQuery,IDDBConstants.COMMAND_UPDATE,vpPO.siteid);
        fPutRASingle("insert into iddbtbcount values('"+vfTName.name+"', '"+vpPO.siteid+"',0)",IDDBConstants.COMMAND_INSERT,vpPO.siteid);
        // masukkan dalam data & log replication
        if(vcReplicatorType!=IDDBConstants.REPLICATOR_NONE)
        {
            vcSUpdate.executeUpdate("insert into iddbtbcount values('"+vfTName.name+"', '"+vpPO.siteid+"',0)");
        }


    }

    private void fCommandExtTableDrop(parserout_t vpPO)  throws SQLException
    {
        //ambil table dari vpPO
        tname_t vfTName = (tname_t) vpPO.table.elements().nextElement();

        // cek apakah ada nama siteid dan table itu, kalau tidak ada error
        ResultSet vfRS=vcSQuery.executeQuery("select * from iddbtbsite where itbname = '"+vfTName.name+"' and isiteid = '"+vpPO.siteid+"'");
        if((vfRS==null)||!vfRS.next())
        {
            vcError.fPutError(1711,"Executor Error : Table: "+vfTName.name+" or Siteid: "+vpPO.siteid+" not exist",true);
            return;
        }


        //hapus record di iddbtbsite
        String vfQueryExtTableDrop="delete from iddbtbsite where isiteid = '"+ vpPO.siteid +"' and itbname = '"+vfTName.name+"'";
        if(vcDebugLevel>=1)
	        System.out.println(vfQueryExtTableDrop);
        vcSUpdate.executeUpdate(vfQueryExtTableDrop);
        //drop table di remote agent
        vfQueryExtTableDrop="drop table "+vfTName.name;
        if(vcDebugLevel>=1)
	        System.out.println(vfQueryExtTableDrop);
        fPutRASingle(vfQueryExtTableDrop,IDDBConstants.COMMAND_DROP_TABLE,vpPO.siteid);
        // delete log table tsb
        vfQueryExtTableDrop="drop table log"+vfTName.name;
        if(vcDebugLevel>=1)
	        System.out.println(vfQueryExtTableDrop);
        fPutRASingle(vfQueryExtTableDrop,IDDBConstants.COMMAND_DROP_TABLE,vpPO.siteid);

        fPutRASingle("delete from iddbtbcount where itbname='"+vfTName.name+"' and isiteid='"+vpPO.siteid+"'",IDDBConstants.COMMAND_DELETE,vpPO.siteid);

        if(vcReplicatorType!=IDDBConstants.REPLICATOR_NONE)
        {
            vcSUpdate.executeUpdate("delete from iddbtbcount where itbname='"+vfTName.name+"' and isiteid='"+vpPO.siteid+"'");
            // delete semua replikasi
	        vcSUpdate.executeUpdate("delete from "+vfTName.name+" where isiteid = '"+vpPO.siteid+"'");
            vcSUpdate.executeUpdate("delete from log"+vfTName.name+" where isiteid = '"+vpPO.siteid+"'");
        }

    }

    private void fCommandExtSiteCreate(parserout_t vpPO)  throws SQLException
    {
        // cek apakah sudah pernah ada ? kalau ada error
        ResultSet vfRS=vcSQuery.executeQuery("select isiteid from iddbsite where isiteid = '"+vpPO.siteid+"'");
        if(vfRS.next())
        {
            vcError.fPutError(1712,"Executor Error : Siteid: "+vpPO.siteid+" already exist",true);
            return;
        }
        // masukkan record di iddbsite
        String vfQuery="insert into iddbsite values ('"+vpPO.siteid+"', "+vpPO.driver+", "+
            vpPO.url+", "+vpPO.user+", '"+ Tools.encrypt(vpPO.user.substring(1,vpPO.user.length()-1),vpPO.password.substring(1,vpPO.password.length()-1))+"')";
        if(vcDebugLevel>=1)
            System.out.println(vfQuery);
        vcSUpdate.executeUpdate(vfQuery);
        if(vcRA.containsKey(vpPO.siteid))
        {
            vcError.fPutError(1712,"Executor Error : Siteid: "+vpPO.siteid+" already exist",true);
            return;
        }
        vcRA.put(vpPO.siteid,new RemoteAgent(this,vpPO.siteid,vpPO.driver.replace(''',' ').trim(),
            vpPO.url.replace(''',' ').trim(),vpPO.user.replace(''',' ').trim(),vpPO.password.replace(''',' ').trim(),vcError,vcDebugLevel));
        fPutRASingle("create table iddbtbcount (itbname char(20) not null,"+
            "isiteid char(20) not null, icounter integer not null)",IDDBConstants.COMMAND_CREATE_TABLE,vpPO.siteid);
        vcSiteList.addElement(vpPO.siteid);
    }

    private void fCommandExtSiteDrop(parserout_t vpPO)  throws SQLException
    {
        ResultSet vfRS=vcSQuery.executeQuery("select isiteid from iddbsite where isiteid = '"+vpPO.siteid+"'");
        if(!vfRS.next())
        {
            vcError.fPutError(1708,"Executor Error : Siteid: "+vpPO.siteid+" not exist",true);
            return;
        }

/*        if(vcReplOn)
        {
            vfRS = vcSQuery.executeQuery("select itbname from iddbtbsite where isiteid = '"+vpPO.siteid+"'");
            while(vfRS.next())
            {
                vcSUpdate.executeUpdate("delete from "+vfRS.getString(1).trim()+" where isiteid = '"+vpPO.siteid+"'");
                vcSUpdate.executeUpdate("delete from log"+vfRS.getString(1).trim()+" where isiteid = '"+vpPO.siteid+"'");

            }
        }
*/        // hapus record siteid dari table iddbsite (tidak menghapus database di Remote Agent")
        String vfQuery="delete from iddbsite where isiteid = '"+vpPO.siteid+"'";
        if(vcDebugLevel>=1)
            System.out.println(vfQuery);
        vcSUpdate.executeUpdate(vfQuery);

        vfQuery="delete from iddbtbsite where isiteid = '"+vpPO.siteid+"'";
        if(vcDebugLevel>=1)
            System.out.println(vfQuery);
        vcSUpdate.executeUpdate(vfQuery);
        // delete semua table replikasi site tersebut.

        // for semua table
        // repXXXX diberi perintah delete where isiteid- vpPO.siteid.
        fPutRASingle("drop table iddbtbcount",IDDBConstants.COMMAND_DROP_TABLE,vpPO.siteid);
        vcSiteList.removeElement(vpPO.siteid);
        ((RemoteAgent)vcRA.remove(vpPO.siteid)).close();
    }

    private void fExecuteCommand(parserout_t vpPO,Vector vpScheduleList)
    {
        if(vcReplicatorType==IDDBConstants.REPLICATOR_ASYN)
        {
            while(vcRepl.vcLockReplicator);
            vcRepl.vcLock=true;
        }

        String vfLevel=null;

        try
        {
            switch(vpPO.command)
            {
                case IDDBConstants.COMMAND_CREATE_TABLE:
                        if(vpPO.vcUserLevel<=IDDBConstants.USER_LEVEL_ROOT)
                            fCommandCreateTable(vpPO);
                        else
                            vfLevel="ROOT";
                        break;
                case IDDBConstants.COMMAND_DROP_TABLE:
                        if(vpPO.vcUserLevel<=IDDBConstants.USER_LEVEL_ROOT)
                            fCommandDropTable(vpPO);
                        else
                            vfLevel="ROOT";
    			        break;
                case IDDBConstants.COMMAND_INSERT:
                        if(vpPO.vcUserLevel<=IDDBConstants.USER_LEVEL_USER)
                            fCommandInsert(vpPO);
                        else
                            vfLevel="USER";
                        break;
                case IDDBConstants.COMMAND_DELETE:
                        if(vpPO.vcUserLevel<=IDDBConstants.USER_LEVEL_USER)
                            fCommandDelete(vpPO);
                        else
                            vfLevel="USER";
                        break;
                case IDDBConstants.COMMAND_UPDATE:
                        if(vpPO.vcUserLevel<=IDDBConstants.USER_LEVEL_USER)
                            fCommandUpdate(vpPO);
                        else
                            vfLevel="USER";
                        break;
                case IDDBConstants.COMMAND_SELECT:
                        if(vpPO.vcUserLevel<=IDDBConstants.USER_LEVEL_GUEST)
                            fCommandSelect(vpPO,vpScheduleList);
                        else
                            vfLevel="GUEST";
                        break;
                case IDDBConstants.COMMAND_EXT_TABLE_CREATE:
                        if(vpPO.vcUserLevel<=IDDBConstants.USER_LEVEL_ROOT)
                            fCommandExtTableCreate(vpPO);
                        else
                            vfLevel="ROOT";
                        break;
                case IDDBConstants.COMMAND_EXT_TABLE_DROP:
                        if(vpPO.vcUserLevel<=IDDBConstants.USER_LEVEL_ROOT)
                            fCommandExtTableDrop(vpPO);
                        else
                            vfLevel="ROOT";
                        break;
                case IDDBConstants.COMMAND_EXT_SITE_CREATE:
                        if(vpPO.vcUserLevel<=IDDBConstants.USER_LEVEL_SYSDBA)
                            fCommandExtSiteCreate(vpPO);
                        else
                            vfLevel="SYSDBA";
                        break;
                case IDDBConstants.COMMAND_EXT_SITE_DROP:
                        if(vpPO.vcUserLevel<=IDDBConstants.USER_LEVEL_SYSDBA)
                            fCommandExtSiteDrop(vpPO);
                        else
                            vfLevel="SYSDBA";
                        break;
            }
		}catch(SQLException vfEx)
		{
            vcError.fPutError(1713,"Executor Error : While execute a command: "+vpPO.query,true);
		}
        if(vcReplicatorType==IDDBConstants.REPLICATOR_ASYN)
            vcRepl.vcLock=false;

        if(vfLevel!=null)
		{
//		    System.out.println("Error user: "+vpPO.vcUser+", have level must "+vfLevel+" or higher !");
		    vcError.fPutError(1714,"Executor Error : User: "+vpPO.vcUser+", must have level "+vfLevel+" or higher !",true);
		    vcRSOut = null;
		}

    }

    public ResultOut executeQuery(parserout_t vpPO, Vector ScheduleList)
    {
        fExecuteCommand(vpPO,ScheduleList);
        return vcRSOut;
    }

    private void fCloseRA()
    {
        for (Enumeration vfEn = vcRA.elements() ; vfEn.hasMoreElements() ;)
        {
            ((RemoteAgent)vfEn.nextElement()).close();
        }
        vcRA.clear();
    }

    private void fInitRA()
    {
        fGetRADb();

        for (Enumeration vfEn = vcSite.elements() ; vfEn.hasMoreElements() ;)
        {
            String[] vfStr= (String[])vfEn.nextElement();

            if(vcDebugLevel>=1)
                System.out.println("Init RA : "+vfStr[0]+" | "+vfStr[1]+" | "+vfStr[2]+" | "+vfStr[3]+" | "+vfStr[4]);

            vcRA.put(vfStr[0],new RemoteAgent(this,vfStr[0],vfStr[1],vfStr[2],vfStr[3],vfStr[4],vcError,vcDebugLevel));
        }
    }

    private void fGetRADb() // throws SQLException
	{
		try
		{
			ResultSet vfRS = vcSUpdate.executeQuery("select * from iddbsite");
            while(vfRS.next())
            {
	            String[] vfStr = new String[5];
		        vfStr[0] = vfRS.getString(1).trim();
		        vfStr[1] = vfRS.getString(2).trim();
		        vfStr[2] = vfRS.getString(3).trim();
		        vfStr[3] = vfRS.getString(4).trim();
		        vfStr[4] = Tools.decrypt(vfStr[3],vfRS.getString(5).trim());
                vcSite.addElement(vfStr);
                vcSiteList.addElement(vfStr[0]);
			}
		} catch (SQLException vfEx) {

		    vcError.fPutError(1715,"Executor Error : While load data SiteId from table 'iddbsite'");
	    }
	}

    synchronized void fResultQuery(String vpSiteId,ResultSet vpRS)
    {
        vcRSOut.RS.addElement(vpRS);
        vcSiteListCurrent.removeElement(vpSiteId);
//            System.out.println("OUT fResultQuery"+vpSiteId);
        if(vcSiteListCurrent.size()==0)
            vcPutRALock=false;
    }

    synchronized void fResultUpdate(String vpSiteId,int vpRSi)
    {
        vcRSOut.RSi+=vpRSi;
        vcSiteListCurrent.removeElement(vpSiteId);
//            System.out.println("OUT fResultUpdate"+vpSiteId);
        if(vcSiteListCurrent.size()==0)
            vcPutRALock=false;
    }


}
