import java.io.*;
import java.util.*;

public class FileConfig {
    Properties pserver = new Properties();
    Properties pdbmsprimary = new Properties();
    String fileIn="IDDBMaster.ini";

    public FileConfig() throws IOException
    {
	    initfile();
    }

    void initfile() throws IOException
    {
    	FileInputStream f = null;
    	String tokena=null,tokenb=null;
    	int state=1;

    	f = openfile(fileIn);
    	DataInputStream d = new DataInputStream(f);
    	if ( d!=null )
    	{
        	while(d.available()>0)
            {
                String strline=d.readLine();

		        strline.toLowerCase();

                StringTokenizer st = new StringTokenizer(strline,"= ");
        	    if (st.countTokens()>0)
        		{
            		tokena = st.nextToken();
            		if (st.countTokens()==0)
            		{
            		    if(tokena.equals("[server]"))
            			state=1;
            		    else if(tokena.equals("[dbmsprimary]"))
            			state=2;
            		}
            		else
            		{
            		    tokenb = st.nextToken();
            		    switch(state)
            		    {
            			case 1:
            					pserver.put(tokena,tokenb);
            					break;
            			case 2:
            					pdbmsprimary.put(tokena,tokenb);
            					break;
            			}
            		}
            	}
    	    }

    	    d.close();
    	    f.close();  // close and free up system resource.
    	}
    }

    FileInputStream openfile(String fileIn) throws IOException
    {
        FileInputStream fin;
        try
        {
            fin= new FileInputStream (fileIn);
        }catch (FileNotFoundException e)
        {
            System.out.println("Warning: Create new file configuration : IDDBMaster.ini");
            System.out.println("Warning: You must change option for your environment, especially for [dbmsprimary] options !");

            String[] data = { "[server]",
                            "optimizer = semijoin",
                            "transaction = concurrent",
                            "insert = fragment",
                            "replicator = synchronous",
                            "repl_time_asyn = 10000",
                            "",
                            "[dbmsprimary]",
  	                        "driver = sun.jdbc.odbc.JdbcOdbcDriver",
                            "url = jdbc:odbc:iddbmaster",
                            "user = junus",
                            "password = junarto"};

            FileOutputStream fout = new FileOutputStream (fileIn);
            for(int i=0;i<data.length;i++)
            {
                for(int j=0;j<data[i].length();j++)
                    fout.write((int)data[i].charAt(j));
                fout.write((int)'\r');
                fout.write((int)'\n');
            }
            fout.close();
            fin= new FileInputStream (fileIn);
        }
        return fin;
    }

    public Properties getServer()
    {
        return pserver;
    }

    public Properties getDBMSPrimary()
    {
        return pdbmsprimary;
    }
}

