import java.io.*;
import java.sql.*;
import java.util.*;


class MainManager implements Runnable
{
    private Thread vcMainThread;
    private Statement vcSQuery;
    private IDDBMaster vcIM;
//    private DataInputStream vcInputKey;
    private ErrorManager vcError;

    MainManager(IDDBMaster vpIM,ErrorManager vpError)
    {
        vcSQuery=vpIM.vcStatement;
        vcIM=vpIM;
//        vcInputKey=new DataInputStream(System.in);

        vcError=vpError;

        vcMainThread = new Thread(this);
        vcMainThread.start();
    }

    public void run()
    {
        try
        {
            System.out.print("Press q to quit or s to see status connection.\n");
            boolean vfExit=false;
            do
            {
//                while(System.in.available()==0);
                char vfInChar = (char) System.in.read();
//                char vfInChar = (char) ((int) vcInputKey.readChar()>>8);
                switch(vfInChar)
                {
                    case 'q':
                    case 'Q':
                        int vfConnectorCount = vcIM.fGetConnectorCount();
                        if(vfConnectorCount>0)
                        {
                            System.out.print("It has "+vfConnectorCount+" connection ");
                            System.out.print("Do you still want to exit ? [y/n] : ");
                            do {
                                while(System.in.available()==0);
                                vfInChar =(char) System.in.read();
                            } while((vfInChar!='n')&&(vfInChar!='N')&&(vfInChar!='y')&&(vfInChar!='Y'));

                            switch(vfInChar)
                            {
                                case 'y':
                                case 'Y':
                                    vfExit=true;
                                    System.out.println("\nIDDBMaster Exit");
                                    break;
                            }
                        } else
                        {
                            vfExit=true;
                            System.out.println("IDDBMaster Exit");
                        }
                        break;

                    case 's':
                    case 'S':
                        vfConnectorCount = vcIM.fGetConnectorCount();
                        System.out.print("Status : "+vfConnectorCount+" connection\n");
                        break;

  /*                        System.out.print("Password : ");
                        String password=vcInputKey.readLine();
                        try
                        {
                            ResultSet vfRS=vcSQuery.executeQuery("select ipassword from iddbuser where iuser='sysdba'");
                            if(vfRS.getString(1).equals(password))
                                vfExit=true;
                            else
                                System.out.print("Wrong password for SYSDBA user");
                		} catch (SQLException vfEx2) {
                		    System.out.println("Exception: " + vfEx2.toString());
                		}
*/
/*                        vfExit=true;
                        System.out.println("IDDBMaster Exit");
                        break;
*/
                }
            } while(!vfExit);
            vcIM.close();
            System.exit(0);
		} catch (IOException vfEx) {
		    vcError.fPutError(1001,"IDDBMaster Error : In MainManager, Exception: " + vfEx.toString());
		}
    }

    public void resume() { vcMainThread.resume(); }

    public void stop() { vcMainThread.stop(); }
}

/**
 * @version 1.0 15-APR-1997
 *
 * This class is used by Connection & PGlobj for communicating with the
 * backend.
 *
 * @see java.sql.Connection
 */
//  This class handles all the Streamed I/O for a postgresql connection
public class IDDBMaster
{
    int vcOperationQuery=2;

    private Executor vcExecutor;
    private ErrorManager vcError;
    private CommunicationManager vcCommunicationManager;
    private TransactionManager vcTransactionManager;
    private UserAuthentication vcUserAuthentication;

  	private String vcDriver;
	private String vcUrl;
	private String vcUser;
	private String vcPassword;
	private Connection vcConnection;
	public Statement vcStatement;

    private String vcOwner="junus";
    private int vcDebugLevel=0;

    public boolean init() throws IOException
    {
        FileConfig vfFileConfig= new FileConfig();
    	Properties vfPDBMSPrimary = vfFileConfig.getDBMSPrimary();
        vcDriver=vfPDBMSPrimary.getProperty("driver");
        vcUrl=vfPDBMSPrimary.getProperty("url");
        vcUser=vfPDBMSPrimary.getProperty("user");
        vcPassword=vfPDBMSPrimary.getProperty("password");


    	Properties vfPServer = vfFileConfig.getServer();

    	int vfOptimizerType=0;
    	int vfTransType=0;
    	int vfInsertType=0;
    	int vfReplicatorType=0;
    	int vfReplTimeAsyn=0;

        String vfTemp=vfPServer.getProperty("optimizer");
        if(vfTemp.equalsIgnoreCase("semijoin"))
            vfOptimizerType=IDDBConstants.OPTIMIZER_SEMIJOIN;
        else
        if(vfTemp.equalsIgnoreCase("replicator"))
            vfOptimizerType=IDDBConstants.OPTIMIZER_REPLICATOR;
        else
        if(vfTemp.equalsIgnoreCase("direct"))
            vfOptimizerType=IDDBConstants.OPTIMIZER_DIRECT;

        vfTemp=vfPServer.getProperty("transaction");
        if(vfTemp.equalsIgnoreCase("single"))
            vfTransType=IDDBConstants.TRANS_SINGLE;
        else
        if(vfTemp.equalsIgnoreCase("concurrent"))
            vfTransType=IDDBConstants.TRANS_CONCURRENT;
        else
        if(vfTemp.equalsIgnoreCase("none"))
            vfTransType=IDDBConstants.TRANS_NONE;

        vfTemp=vfPServer.getProperty("insert");
        if(vfTemp.equalsIgnoreCase("random"))
            vfInsertType=IDDBConstants.INSERT_RANDOM;
        else
        if(vfTemp.equalsIgnoreCase("order"))
            vfInsertType=IDDBConstants.INSERT_ORDER;
        else
        if(vfTemp.equalsIgnoreCase("fragment"))
            vfInsertType=IDDBConstants.INSERT_FRAGMENT;

        String vfReplicator=vfPServer.getProperty("replicator");
        if(vfReplicator.equalsIgnoreCase("synchronous"))
            vfReplicatorType=IDDBConstants.REPLICATOR_SYN;
        else
        if(vfReplicator.equalsIgnoreCase("asynchronous"))
            vfReplicatorType=IDDBConstants.REPLICATOR_ASYN;
        else
        if(vfReplicator.equalsIgnoreCase("none"))
            vfReplicatorType=IDDBConstants.REPLICATOR_NONE;
        vfReplTimeAsyn = Integer.valueOf(vfPServer.getProperty("repl_time_asyn")).intValue();

        if((vfOptimizerType==IDDBConstants.OPTIMIZER_REPLICATOR)&&(vfReplicatorType==IDDBConstants.REPLICATOR_NONE))
        {
            System.out.println("1002, IDDBMaster Error : File configuration IDDBMaster.ini: optimizer = replicator, but replicator = off !");
            return false;
        }


        initdb();
		try
		{
            fCheckTableExist();
    	} catch (SQLException vfEx) {
            System.out.println("1003, IDDBMaster Error : While check existing MAIN table catalog IDDB, Exception: "+ vfEx.toString());
            return false;
		}

        vcError = new ErrorManager(vcDebugLevel);
        vcUserAuthentication=new UserAuthentication(vcConnection,vcError);
        vcCommunicationManager = new CommunicationManager(vcUserAuthentication,vfOptimizerType, vcError,vcDebugLevel);
        vcError.fInsertCommunicationManager(vcCommunicationManager);
        vcExecutor = new Executor(vcConnection, vfInsertType,vfOptimizerType,vfReplicatorType,vfReplTimeAsyn,vcError,vcDebugLevel);
        vcTransactionManager = new TransactionManager(vcStatement,vcUserAuthentication, vfTransType,vfOptimizerType,vcError,vcDebugLevel);
        vcCommunicationManager.fInsertTransactionManager(vcTransactionManager);
        vcTransactionManager.fInsertExecutor(vcExecutor);

        return true;
    }

    public int fGetConnectorCount()
    {
        return vcCommunicationManager.fGetConnectorCount();
    }

	public static void main(String argv[]) throws IOException
	{
	    System.out.println("ITS Distributed DataBase (IDDB)");
	    System.out.println("Version 0.1.0 (alpha), June 1998");
	    System.out.println("Copyright (C) Junus Junarto Djunawidjaja   ( e-mail: junus@its-sby.edu )");
	    System.out.println("Informatic Engineering ITS");
	    System.out.println();

        IDDBMaster vfIM = new IDDBMaster();
	    if(argv.length == 1)
	    {
	        if(argv[0].indexOf("-d")<0)
	        {
	            System.out.println("Wrong argument");
	            System.out.println("Syntax : java IDDBMaster [-d[1-3]]");
	            System.out.println("         -d : debugging level");
	            return;
	        }
	        else
	        {
	            if(argv[0].length()>2)
	            {
                    vfIM.vcDebugLevel=Integer.valueOf(argv[0].substring(2)).intValue();
                    if(!((vfIM.vcDebugLevel>=1)&&(vfIM.vcDebugLevel<=3)))
        	        {
        	            System.out.println("Wrong argument level of debugging");
        	            System.out.println("Syntax : java IDDBMaster [-d[1-3]]");
        	            System.out.println("         -d : debugging level");
        	            return;
        	        }
	            }
	            else
	                vfIM.vcDebugLevel=1;
	        }
	    } else
	    {
    	    if(argv.length > 1)
    	    {
                System.out.println("Wrong argument");
                System.out.println("Syntax : java IDDBMaster [-d[1-3]]");
                System.out.println("         -d : debugging level");
                return;
            }
        }

        if(vfIM.init())
        {
            MainManager MManager=new MainManager(vfIM,vfIM.vcError);
            vfIM.run();
            vfIM.close();
        }
    }

    public void run() throws IOException
    {
        vcCommunicationManager.fRun();

/*
        try
        {
        TransactionManager s=vcTransactionManager;


        s.executeUpdate("extended site create au, 'interbase.interclient.Driver', "+
        "'jdbc:interbase://junus/d:\\au.gdb', 'junus', 'junarto'",vcOwner);
        s.executeUpdate("extended site create id, 'interbase.interclient.Driver', "+
        "'jdbc:interbase://junus/d:\\id.gdb', 'junus', 'junarto'",vcOwner);

*/
/*        s.executeUpdate("extended site create au, 'interbase.interclient.Driver', "+
        "'jdbc:interbase://junus/d:\\au.gdb', 'junus', 'junarto'",vcOwner);
        s.executeUpdate("extended site create id, 'postgresql.Driver', "+
        "'jdbc:postgresql://192.168.0.3/id', 'junus', 'junarto'",vcOwner);
        s.executeUpdate("extended site create us, 'gwe.sql.gweMysqlDriver', "+
        "'jdbc:mysql://192.168.0.3:3306/us', 'junus', 'junarto'",vcOwner);
*/
/*        s.executeUpdate("extended site create au, 'interbase.interclient.Driver', "+
        "'jdbc:interbase://junus/d:\\au.gdb', 'junus', 'junarto'",vcOwner);
        s.executeUpdate("extended site create id, 'interbase.interclient.Driver', "+
        "'jdbc:interbase://junus/d:\\id.gdb', 'junus', 'junarto'",vcOwner);
        s.executeUpdate("extended site create us, 'interbase.interclient.Driver', "+
        "'jdbc:interbase://junus/d:\\us.gdb', 'junus', 'junarto'",vcOwner);
*/
/*         s.executeUpdate("extended site create au, 'postgresql.Driver', "+
        "'jdbc:postgresql://junus/au', 'junus', 'junarto'");
        s.executeUpdate("extended site create id, 'postgresql.Driver', "+
        "'jdbc:postgresql://junus/id', 'junus', 'junarto'");
        s.executeUpdate("extended site create us, 'postgresql.Driver', "+
        "'jdbc:postgresql://junus/us', 'junus', 'junarto'");
*/

/*
//	System.out.println("create table test");
        s.executeUpdate("create table test (a char(20), b integer)",vcOwner);
//	System.out.println("create table test FINISH");

        s.executeUpdate("extended table create test site au fragment a = 'Australia'",vcOwner);
        s.executeUpdate("extended table create test site id fragment a = 'Indonesia' default",vcOwner);

//        s.executeUpdate("extended table create test site us fragment a = 'USA'",vcOwner);

        s.executeUpdate("insert into test values ('Australia',1)",vcOwner);
        s.executeUpdate("insert into test values ('Indonesia',2)",vcOwner);
        s.executeUpdate("insert into test values ('USA',3)",vcOwner);
        s.executeUpdate("insert into test values ('tidak ada',4)",vcOwner);


        s.executeUpdate("delete from test where b=2 and a='Indonesia'",vcOwner);
        s.executeUpdate("delete from test where b=1 and a='Indonesia'",vcOwner);
        s.executeUpdate("delete from test where b=1 or a='Indonesia'",vcOwner);
        s.executeUpdate("delete from test where b=4",vcOwner);
        s.executeUpdate("delete from test where a='Australia'",vcOwner);
        s.executeUpdate("delete from test where b=5",vcOwner);

        s.executeUpdate("update test set a='Australia' where a='Indonesia'",vcOwner);
        s.executeUpdate("update test set b=5 where a='USA' and b=3",vcOwner);
*/

//        s.executeUpdate("extended table create test site id fragment country = 'Indonesia' or country = 'Australia' and country = 'USA' default",vcOwner);
//		System.out.println("Now lets try a select");
//        rs=s.executeQuery("select a.full_name, b.proj_id from employee a, employee_project b where a.emp_no=b.emp_no");
//        rs=executor.executeQuery("select a.full_name, b.proj_id, c.proj_name from employee a, employee_project b, project c where a.emp_no=b.emp_no and b.proj_id=c.proj_id");

//		System.out.println("********************************* select ******************");
//        ResultSet rs=null;
//	        rs=s.executeQuery("select * from test");
//		System.out.println("Back for the select...the following are results :");
/*        if(rs!=null)
        {
        	int i = 0;
        	String tmp="";
        	ResultSetMetaData rsmd=rs.getMetaData();
        	int nf=rsmd.getColumnCount();
        	while (rs.next())
        	{
        		System.out.print("row(" + i + "):");
        	    for(int x=1;x<=nf;x++)
        	    {
                    switch (rsmd.getColumnType(x))
                    {
                        case Types.CHAR:
                            tmp=rs.getString(x);
                            break;
                        case Types.INTEGER:
                            tmp=""+rs.getInt(x);
                            break;
                        case Types.FLOAT:
                            tmp=""+rs.getFloat(x);
                            break;
                    }
        		    System.out.print("|"+tmp);
                }
        		System.out.println("|");
        		i++;
        	}
        	rs=null;
        	rsmd=null;

	        s.executeQueryEnd();
        }

		} catch (SQLException vfEx) {
		    System.out.println("Exception: " + vfEx.toString());
		}
*/    }

    public void close() throws IOException
    {
//        vcTransactionManager.close();
        vcCommunicationManager.close();
        vcExecutor.close();
        vcUserAuthentication.close();
        closedb();
    }

    private void initdb()
    {

//   	  String ddrv = "interbase.interclient.Driver";
//   	  String durl = "jdbc:interbase://junus/d:\\pusat.gdb";

//        String ddrv = "postgresql.Driver";
//	      String durl = "jdbc:postgresql://junus/pusat";

//        String ddrv = "sun.jdbc.odbc.JdbcOdbcDriver";
//        String durl = "jdbc:odbc:iddbmaster";

//	    String duser = "junus";
//	    String dpassword = "junarto";

//Open the driver manager's log stream
        if(vcDebugLevel>=3)
            DriverManager.setLogStream(System.out);

//Create the driver object
//java.sql.Driver icDriver = new interbase.interclient.Driver();
//Trace method invocations by printing messages to this monitor's
//trace stream
//((interbase.interclient.Driver)icDriver).getMonitor().setTraceStream(System.out);
/*		try
		{
            ((interbase.interclient.Driver)icDriver).getMonitor().enableAllTraces (true);
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
*/

		try
		{
			Class.forName(vcDriver);
    		try
    		{
    		    vcConnection = DriverManager.getConnection(vcUrl, vcUser, vcPassword);
    		    vcStatement = vcConnection.createStatement();
    		} catch (SQLException vfEx) {
		        vcError.fPutError(1004,"IDDBMaster Error : While Initialisation Connection to MAIN DBMS, Exception: " + vfEx.toString());
    		}
		} catch (ClassNotFoundException vfEx) {
		    vcError.fPutError(1005,"IDDBMaster Error : While Try to load class Driver JDBC MAIN DBMS, Exception: " + vfEx.toString());
		}

    }

    private void closedb()
    {
        try
        {
		    vcStatement.close();
		    vcConnection.close();
		} catch (SQLException vfEx) {
		    vcError.fPutError(1006,"IDDBMaster Error : Fail in close, Exception: " + vfEx.toString());
		}
	}

    private boolean fCheckTable(String vpStrTable, String vpStrCreate) throws SQLException
    {
        String vfTablex="table";
        try
        {
    	    vcStatement.executeUpdate(vpStrCreate);
    	    return false;
    	} catch (SQLException vfEx) {
    	    if((vfEx.toString().toLowerCase().indexOf(vfTablex)==-1)&&
     	      (vfEx.toString().toLowerCase().indexOf("create")==-1))
   	        throw new SQLException(vfEx.toString());
    	}
   	    return true;
    }

    private void fCheckTableExist() throws SQLException
    {
    /* Table: IDDBUSER */
        if(!fCheckTable("iddbuser",
                    "CREATE TABLE IDDBUSER (IUSER CHAR(20) NOT NULL ,"+
                    "IPASSWORD CHAR(50),"+
                    "ILEVEL INTEGER)"))
     	    vcStatement.executeUpdate("insert into iddbuser values('sysdba','KretsaMye',0)");

    /* Table: IDDBSITE */
        fCheckTable("iddbsite",
                    "CREATE TABLE IDDBSITE (ISITEID CHAR(20) NOT NULL ,"+
                    "IDRIVER CHAR(50),"+
                    "IURL CHAR(100),"+
                    "IUSER CHAR(20),"+
                    "IPASSWORD CHAR(50))");
    /* Table: IDDBTB */
        fCheckTable("iddbtb",
                    "CREATE TABLE IDDBTB (ITBNAME CHAR(20) NOT NULL,"+
                    "IOWNER CHAR(20))");
    /* Table: IDDBTBFIELD */
        fCheckTable("iddbtbfield",
                    "CREATE TABLE IDDBTBFIELD (ITBNAME CHAR(20) NOT NULL,"+
                    "INAME CHAR(20) NOT NULL,"+
                    "ITYPE INTEGER,"+
                    "ILENGTH INTEGER,"+
                    "INOTNULL INTEGER,"+
                    "IPKEY INTEGER,"+
                    "INO INTEGER)");
    /* Table: IDDBTBSITE */
        fCheckTable("iddbtbsite",
                    "CREATE TABLE IDDBTBSITE (ITBNAME CHAR(20) NOT NULL,"+
                    "ISITEID CHAR(20) NOT NULL,"+
                    "IFNAME CHAR(20) NOT NULL,"+
                    "IFTYPE INTEGER,"+
                    "IFINTEGER INTEGER,"+
                    "IFFLOAT FLOAT,"+
                    "IFCHAR CHAR(50),"+
                    "IFOP INTEGER,"+
                    "IFBOOL INTEGER,"+
                    "IFDEFAULT INTEGER)");
    /* Table: IDDBTBCOUNT */
        fCheckTable("iddbtbcount",
                    "CREATE TABLE IDDBTBCOUNT (ITBNAME CHAR(20) NOT NULL,"+
                    "ISITEID CHAR(20) NOT NULL,"+
                    "ICOUNTER INTEGER NOT NULL)");
    /* Table: IDDBLOG */
        if(!fCheckTable("iddblog",
                    "CREATE TABLE IDDBLOG (IDATE CHAR(40) NOT NULL,"+
                    "ICOUNTER INTEGER NOT NULL,"+
                    "IOPERATION CHAR(250),"+
                    "ITYPE INTEGER,"+
                    "IUSER CHAR(20))"))
     	    vcStatement.executeUpdate("insert into iddbtbcount values('log','*',0)");
   }
}
