import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;
import java.sql.*;
/*
class query_t
{
    Integer no;
    String query;
    boolean type;

    public query_t(Integer n, String s, boolean q)
    {
        no=n;
        query=s;
        type=q;
    }
}
*/

class RemoteAgent implements Runnable
{
    private ErrorManager vcError;
    private int vcDebugLevel;

//    private Vector vcQueueIn=new Vector();
    private Executor vcExecutor;
    private String vcSiteId;

    private Thread  vcRAThread;
//    private int vcMaxQueueIn=20;

	private String vcDriver;
	private String vcUrl;
	private String vcUser;
	private String vcPassword;
	private Connection vcConnection;
	private Statement vcSQuery, vcSUpdate;

	private Integer vcQueryNo=null;
	private String vcQuery="";
	private boolean vcQueryType=true;


    public RemoteAgent(Executor vpExecutor,
        String vpSiteId, String vpDriver, String vpUrl, String vpUser, String vpPassword,
        ErrorManager vpError, int vpDebugLevel)
    {
        vcError=vpError;
        vcDebugLevel=vpDebugLevel;

        vcSiteId=vpSiteId;
        vcExecutor=vpExecutor;
        fInitDb(vpDriver,vpUrl,vpUser,vpPassword);
        vcRAThread = new Thread(this);
        vcRAThread.start();
    }

    private void fInitDb(String vpDriver, String vpUrl, String vpUser, String vpPassword)
    {
		vcDriver=vpDriver;
		vcUrl=vpUrl;
		vcUser=vpUser;
		vcPassword=vpPassword;

		try
		{
			Class.forName(vcDriver);
    		try
    		{
    		    vcConnection = DriverManager.getConnection(vcUrl, vcUser, vcPassword);
    		    vcSQuery = vcConnection.createStatement();
    		    vcSUpdate = vcSQuery;
//  		    vcSUpdate = vcConnection.createStatement();
    		} catch (SQLException vfEx) {
    			vcError.fPutError(1501,"Remote Agent Error : Initialisation Fail, Exception: " + vfEx.toString());
    		}
		} catch (ClassNotFoundException vfEx) {
			vcError.fPutError(1501,"Remote Agent Error : Initialisation Fail, Exception: " + vfEx.toString());
		}

    }

    public void closedb()
    {
        try
        {
		    vcSQuery.close();
		    vcSUpdate.close();
		    vcConnection.close();
		} catch (SQLException vfEx) {
			vcError.fPutError(1502,"Remote Agent Error : Close Fail, Exception: " + vfEx.toString());
		}
	}

/*	public synchronized void put(Integer vpQueryNo, String vpQuery, boolean vpQueryType)
	{
	    if(vcQueueIn.size()<vcMaxQueueIn)
	        vcQueueIn.addElement(new query_t(vpQueryNo,vpQuery,vpQueryType));
	    else
	        vcError.fPutError(1501,"Queue RemoteAgent "+vcSiteId+" Full : " + vcQueueIn.size()+" element.");
	}
*/
	public synchronized void put(Integer vpQueryNo, String vpQuery, boolean vpQueryType)
	{
	    if(vcQuery.equals(""))
	    {
	        vcQueryNo=vpQueryNo;
	        vcQuery=vpQuery;
	        vcQueryType=vpQueryType;
	    }
	    else
	    {
//            System.out.println("yang sekarang   siteid:"+vcSiteId+" vcQueryNo:"+vcQueryNo+" query : "+vcQuery);
//            System.out.println("yang akan masuk siteid:"+vcSiteId+" vpQueryNo:"+vpQueryNo+" query : "+vpQuery);
	        vcError.fPutError(1503,"Remote Agent Error : Queue RemoteAgent, siteid: "+vcSiteId+" Full !" );
	        return;
	    }
	}

    public void resume() { vcRAThread.resume(); }

    public void run()
    {
        while(true)
        {
//            if(vcQueueIn.size()>0)
	        if(!vcQuery.equals(""))
            {
//                query_t vfQuery=(query_t) vcQueueIn.firstElement();
//                vcQueueIn.removeElementAt(0);

        	    if(vcDebugLevel>=1)
                    System.out.println("siteid:"+vcSiteId+" vcQueryNo:"+vcQueryNo+" query : "+vcQuery);
        		ResultSet vfRS;
        		int vfRSi;
        		try
        		{
        		    if(vcQueryType)
        		    {
        			    vfRS = vcSQuery.executeQuery(vcQuery);
        			    // replicator.executeQuery(q.no,q.query);
                        vcQuery="";
                        vcExecutor.fResultQuery(vcSiteId,vfRS);
                    }
        			else
        			{
        			    vfRSi = vcSUpdate.executeUpdate(vcQuery);
        			    // replicator.executeUpdate(q.no,q.query);
                        vcQuery="";
                        vcExecutor.fResultUpdate(vcSiteId,vfRSi);
                    }
        		} catch (SQLException vfEx) {
                    vcExecutor.fResultUpdate(vcSiteId,-2);
       			    vcQuery="";
       			    vcError.fPutError(1504,"Remote Agent Error : Exception while running, siteid: "+vcSiteId +" vcQueryNo: "+
       			        vcQueryNo+" query: "+vcQuery+" Exception: "+vfEx.toString());
        	    }
            }
        }
    }

    public void stop() { vcRAThread.stop(); }

    public void close()
    {
        this.stop();
        this.closedb();
    }
}