/*
    This class is a basic extension of the Dialog class.  It can be used
    by subclasses of Frame.  To use it, create a reference to the class,
    then instantiate an object of the class (pass 'this' in the constructor),
    and call the show() method.

    example:

    about theabout;
    theabout = new about(this);
    theabout.show();

    You can add controls to AboutBox with Cafe Studio.
    (Menus can be added only to subclasses of Frame.)
 */

import java.awt.*;

public class about extends Dialog {

    public about(Frame parent,String vpDBName, String vpDBVersion) {

	    super(parent, "About",true);

	    //{{INIT_CONTROLS
        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 271, insets().top + insets().bottom + 240);
        label1=new Label("Sistem Informasi Mahasiswa - Kuliah");
        add(label1);
        label1.reshape(insets().left + 26,insets().top + 13,210,13);
        label2=new Label("(c) Junus Junarto D");
        add(label2);
        label2.reshape(insets().left + 75,insets().top + 57,112,13);
        label3=new Label("T. Informatika ITS");
        add(label3);
        label3.reshape(insets().left + 81,insets().top + 80,105,13);
        label4=new Label("Juni 1998");
        add(label4);
        label4.reshape(insets().left + 96,insets().top + 101,70,13);
        label5=new Label("Versi 0.1.0");
        add(label5);
        label5.reshape(insets().left + 102,insets().top + 36,63,13);
        label6=new Label("Driver JDBC :");
        add(label6);
        label6.reshape(insets().left + 15,insets().top + 130,300,13);
        label7=new Label("Name: "+vpDBName);
        add(label7);
        label7.reshape(insets().left + 20,insets().top + 145,300,13);
        label8=new Label("Version: "+vpDBVersion);
        add(label8);
        label8.reshape(insets().left + 20,insets().top + 160,300,13);
        button1=new Button("Ok");
        add(button1);
        button1.reshape(insets().left + 100,insets().top + 190,70,20);
        //}}

    	setResizable(false);
    }

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {
    	if (event.id == Event.ACTION_EVENT && event.target == button1) {
    	    	clickedButton1();
    	    	return true;
    	}
    	else

    	if (event.id == Event.WINDOW_DESTROY) {
    	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
    Label label1;
    Label label2;
    Label label3;
    Label label4;
    Label label5;
    Label label6;
    Label label7;
    Label label8;
    Button button1;
    //}}
    public void clickedButton1() {
        // to do: put event handler code here.
        setVisible(false);
    }
}


