/*
    This class is a basic extension of the Dialog class.  It can be used
    by subclasses of Frame.  To use it, create a reference to the class,
    then instantiate an object of the class (pass 'this' in the constructor),
    and call the show() method.

    example:

    frs_cari thefrs_cari;
    thefrs_cari = new frs_cari(this);
    thefrs_cari.show();

    You can add controls to AboutBox with Cafe Studio.
    (Menus can be added only to subclasses of Frame.)
 */

import java.awt.*;
import java.sql.*;

public class frs_cari extends Dialog {

    Statement s;
    int fmode,fstate=1;
    String oldnrp, oldkode;

    public frs_cari(Frame parent, String title, Statement s, int fmode, String strGlobal) {

	    super(parent, title, true);
	    this.s=s;
	    this.fmode=fmode;

	    //{{INIT_CONTROLS
        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 378, insets().top + insets().bottom + 180);
        label6=new Label("Jurusan");
        add(label6);
        label6.reshape(insets().left + 40,insets().top + 85,56,17);
        label1=new Label("NRP");
        add(label1);
        label1.reshape(insets().left + 40,insets().top + 29,56,17);
        label2=new Label("Kode");
        add(label2);
        label2.reshape(insets().left + 40,insets().top + 57,56,18);
        choice2= new Choice();
        add(choice2);
        choice2.reshape(insets().left + 110,insets().top + 28,167,24);
        choice3= new Choice();
        add(choice3);
        choice3.reshape(insets().left + 110,insets().top + 54,168,26);
        choice1= new Choice();
        add(choice1);
        choice1.reshape(insets().left + 110,insets().top + 85,112,26);
        if(fmode==4)
        {
            label1.hide();
            label2.hide();
            label6.hide();

	        group1= new CheckboxGroup();
            check1=new Checkbox("NRP",group1,true);
            add(check1);
            check1.reshape(insets().left + 25,insets().top + 29,56,17);
            check2=new Checkbox("Kode",group1,false);
            add(check2);
            check2.reshape(insets().left + 25,insets().top + 57,56,17);
            check3=new Checkbox("Jurusan");
            add(check3);
            check3.reshape(insets().left + 25,insets().top + 85,70,17);
            if(strGlobal!=null)
                check3.setEnabled(false);
            clickedCheck1();
            clickedCheck3();
        }
        button1=new Button("Find");
        add(button1);
        button1.reshape(insets().left + 156,insets().top + 114,91,26);
        button2=new Button("Close");
        add(button2);
        button2.reshape(insets().left + 261,insets().top + 114,91,26);
        //}}
        if(strGlobal==null)
        {
            try {
                ResultSet rs = s.executeQuery("select * from jurusan");
                while(rs.next())
                {
                    choice1.add(rs.getString(1));
                }
    		} catch (SQLException e) {
    		    System.out.println("Exception: " + e.toString());
    		}
		}
		else
		{
		    choice1.add(strGlobal);
		    choice1.setEnabled(false);
		}

        try {
            ResultSet rs = s.executeQuery("select nrp from mahasiswa");
            while(rs.next())
            {
                choice2.add(rs.getString(1));
            }
            rs = s.executeQuery("select kode from kuliah");
            while(rs.next())
            {
                choice3.add(rs.getString(1));
            }
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}

    	setResizable(false);
    }

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {
        	if (event.id == Event.ACTION_EVENT && event.target == check3) {
        	    	clickedCheck3();
        	    	return true;
        	}
        	else
        	if (event.id == Event.ACTION_EVENT && event.target == check2) {
        	    	clickedCheck2();
        	    	return true;
        	}
        	else
        	if (event.id == Event.ACTION_EVENT && event.target == check1) {
        	    	clickedCheck1();
        	    	return true;
        	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == button2) {
    	    	clickedButton2();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == button1) {
    	    	clickedButton1();
    	    	return true;
    	}
    	else

    	if (event.id == Event.WINDOW_DESTROY) {
    	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
	CheckboxGroup group1;
    Button button1;
    Button button2;
    Choice choice1;
    Label label6;
    Label label1;
    Label label2;
    Choice choice2;
    Choice choice3;
    Checkbox check1;
    Checkbox check2;
    Checkbox check3;
    //}}
    public void clickedButton1() {
        // to do: put event handler code here.
        try {
            if(fstate==1)
            {
                ResultSet rs;
                String tmp;
                if(fmode==4)
                {
                    if(check1.getState())
                        tmp = "select * from frs where nrp = '"+choice2.getSelectedItem().trim()+"' "+(check3.getState() ? "and kodejur = '"+choice1.getSelectedItem().trim()+"'" : "");
                    else
                        tmp = "select * from frs where kode = '"+choice3.getSelectedItem().trim()+"' "+(check3.getState() ? "and kodejur = '"+choice1.getSelectedItem().trim()+"'" : "");
                }
                else
                    tmp = "select * from frs where nrp = '"+choice2.getSelectedItem().trim()+"' and kode = '"+choice3.getSelectedItem().trim()+"' and kodejur = '"+choice1.getSelectedItem().trim()+"'";
//                System.out.println(tmp);
                rs = s.executeQuery(tmp);
                if(rs.next())
                {
                    oldnrp=rs.getString(1);
                    oldkode=rs.getString(2);
                }
                else
                {
                    DMesg d = new DMesg((Frame)getParent(),"Error","NRP atau Kode tidak ketemu !");
                    d.show();
                    return;
                }
                switch(fmode)
                {
                    case 1:
                        button1.setLabel("Update");
                        choice2.setEnabled(true);
                        choice3.setEnabled(true);
                        break;
                    case 2:
                        button1.setLabel("Delete");
                        choice2.setEnabled(false);
                        choice3.setEnabled(false);
                        break;
                    case 3:
                        button1.setVisible(false);
                        choice2.setEnabled(false);
                        choice3.setEnabled(false);
                        break;
                    case 4:
                        dispose();
                        return;
                }
                fstate=2;
                choice1.setEnabled(false);
            } else if(fstate==2)
            {
                if(choice2.getSelectedItem().equals("") || choice3.getSelectedItem().equals(""))
                {
                    DMesg d = new DMesg((Frame)getParent(),"Error","Kode atau Nama tidak boleh kosong !");
                    d.show();
                    return;
                }
                switch(fmode)
                {
                    case 1:
                        s.executeUpdate("update frs set nrp = '"+choice2.getSelectedItem().trim()+"', kode = '"+choice3.getSelectedItem().trim()+"' where nrp = '"+oldnrp+"' and kode = '"+oldkode.trim()+"' and kodejur = '"+choice1.getSelectedItem().trim()+"'");
                        break;
                    case 2:
                        s.executeUpdate("delete from frs where nrp = '"+choice2.getSelectedItem().trim()+"' and kode = '"+choice3.getSelectedItem().trim()+"' and kodejur = '"+choice1.getSelectedItem().trim()+"'");
                        break;
                }
                dispose();
            }
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
    }
    public void clickedButton2() {
        // to do: put event handler code here.
        fclose=false;
        dispose();
    }
    public void clickedCheck1() {
        // to do: put event handler code here.
        choice2.setEnabled(true);
        choice3.setEnabled(false);
    }
    public void clickedCheck2() {
        // to do: put event handler code here.
        choice2.setEnabled(false);
        choice3.setEnabled(true);
    }
    public void clickedCheck3() {
        // to do: put event handler code here.
        choice1.setEnabled(check3.getState());
    }
    boolean fclose=true;
    public boolean getClose() {
        // to do: put event handler code here.
        return fclose;
    }
    public String getNrp() {
        // to do: put event handler code here.
        String nrp=null;
        if(check1.getState())
            nrp=choice2.getSelectedItem();
        return nrp;
    }
    public String getKode() {
        // to do: put event handler code here.
        String kode=null;
        if(check2.getState())
            kode=choice3.getSelectedItem();
        return kode;
    }
    public String getJurusan() {
        // to do: put event handler code here.
        String jurusan=null;
        if(check3.getState())
            jurusan=choice1.getSelectedItem();
        return jurusan;
    }

}


