/*
    This class is a basic extension of the Dialog class.  It can be used
    by subclasses of Frame.  To use it, create a reference to the class,
    then instantiate an object of the class (pass 'this' in the constructor),
    and call the show() method.

    example:

    frs_tambah thefrs_tambah;
    thefrs_tambah = new frs_tambah(this);
    thefrs_tambah.show();

    You can add controls to AboutBox with Cafe Studio.
    (Menus can be added only to subclasses of Frame.)
 */

import java.awt.*;
import java.sql.*;

public class frs_tambah extends Dialog {

    Statement s;

    public frs_tambah(Frame parent, Statement s, String strGlobal) {

	    super(parent, "FRS Tambah", true);

	    this.s=s;

        //{{INIT_CONTROLS
        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 379, insets().top + insets().bottom + 179);
        label1=new Label("NRP");
        add(label1);
        label1.reshape(insets().left + 12,insets().top + 23,56,19);
        label2=new Label("Kode");
        add(label2);
        label2.reshape(insets().left + 12,insets().top + 49,56,19);
        label6=new Label("Jurusan");
        add(label6);
        label6.reshape(insets().left + 12,insets().top + 75,56,19);
        choice2= new Choice();
        add(choice2);
        choice2.reshape(insets().left + 89,insets().top + 23,120,19);
        choice3= new Choice();
        add(choice3);
        choice3.reshape(insets().left + 89,insets().top + 49,120,19);
        choice1= new Choice();
        add(choice1);
        choice1.reshape(insets().left + 89,insets().top + 75,112,26);
        button1=new Button("Ok");
        add(button1);
        button1.reshape(insets().left + 180,insets().top + 120,91,20);
        button2=new Button("Cancel");
        add(button2);
        button2.reshape(insets().left + 292,insets().top + 120,77,20);
        //}}
        if(strGlobal==null)
        {
            try {
                ResultSet rs = s.executeQuery("select * from jurusan");
                while(rs.next())
                {
                    choice1.add(rs.getString(1));
                }
    		} catch (SQLException e) {
    		    System.out.println("Exception: " + e.toString());
    		}
		}
		else
		{
		    choice1.add(strGlobal);
		    choice1.setEnabled(false);
		}

        try {
            ResultSet rs = s.executeQuery("select nrp from mahasiswa");
            while(rs.next())
            {
                choice2.add(rs.getString(1));
            }
            rs = s.executeQuery("select kode from kuliah");
            while(rs.next())
            {
                choice3.add(rs.getString(1));
            }
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}


    	setResizable(false);
    }

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {
    	if (event.id == Event.ACTION_EVENT && event.target == button2) {
    	    	clickedButton2();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == button1) {
    	    	clickedButton1();
    	    	return true;
    	}
    	else

    	if (event.id == Event.WINDOW_DESTROY) {
    	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
    Label label1;
    Label label2;
    Button button1;
    Button button2;
    Choice choice1;
    Label label6;
    Choice choice2;
    Choice choice3;
    //}}
    public void clickedButton1() {
        // to do: put event handler code here.
        if(choice2.getSelectedItem().equals("") || choice3.getSelectedItem().equals(""))
        {
            DMesg d = new DMesg((Frame)getParent(),"Error","NRP atau Kode tidak boleh kosong !");
            d.show();
            return;
        }
        try {
            s.executeUpdate("insert into frs values ('"+choice2.getSelectedItem()+"', '"+choice3.getSelectedItem()+"', '"+choice1.getSelectedItem().trim()+"')");
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
		dispose();
    }
    public void clickedButton2() {
        // to do: put event handler code here.
        dispose();
    }
}


