/*
    This class is a basic extension of the Dialog class.  It can be used
    by subclasses of Frame.  To use it, create a reference to the class,
    then instantiate an object of the class (pass 'this' in the constructor),
    and call the show() method.

    example:

    global theglobal;
    theglobal = new global(this);
    theglobal.show();

    You can add controls to AboutBox with Cafe Studio.
    (Menus can be added only to subclasses of Frame.)
 */

import java.awt.*;
import java.sql.*;

public class global extends Dialog {

    Statement s;

    public global(Frame parent, Statement s, String sg) {

	    super(parent, "Global", true);

	    this.s=s;

	    //{{INIT_CONTROLS
        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 379, insets().top + insets().bottom + 180);
        group1= new CheckboxGroup();
        button1=new Button("Ok");
        add(button1);
        button1.reshape(insets().left + 161,insets().top + 117,91,26);
        button2=new Button("Cancel");
        add(button2);
        button2.reshape(insets().left + 273,insets().top + 117,91,26);
        check1=new Checkbox("Global",group1, true);
        add(check1);
        check1.reshape(insets().left + 21,insets().top + 26,105,20);
        check2=new Checkbox("Local",group1, false);
        add(check2);
        check2.reshape(insets().left + 21,insets().top + 52,105,20);
        choice1= new Choice();
        add(choice1);
        choice1.reshape(insets().left + 126,insets().top + 52,105,65);
        //}}
        strGlobal=sg;
        try {
            ResultSet rs = s.executeQuery("select * from jurusan");
            while(rs.next())
            {
                choice1.add(rs.getString(1));
            }
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
		if(strGlobal!=null)
		{
		    choice1.select(strGlobal);
		    check2.setState(true);
            clickedCheck2();
		}
		else
		{
		    check1.setState(true);
            clickedCheck1();
        }

    	setResizable(false);
    }

    private String strGlobal;

    public String getGlobal() {
        return strGlobal;
    }

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {
    	if (event.id == Event.ACTION_EVENT && event.target == button2) {
    	    	clickedButton2();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == button1) {
    	    	clickedButton1();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == check2) {
    	    	clickedCheck2();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == check1) {
    	    	clickedCheck1();
    	    	return true;
    	}
    	else

    	if (event.id == Event.WINDOW_DESTROY) {
    	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
    CheckboxGroup group1;
    Button button1;
    Button button2;
    Checkbox check1;
    Checkbox check2;
    Choice choice1;
    //}}
    public void clickedCheck1() {
        // to do: put event handler code here.
        choice1.setEnabled(false);
    }
    public void clickedCheck2() {
        // to do: put event handler code here.
        choice1.setEnabled(true);
    }
    public void clickedButton1() {
        // to do: put event handler code here.
        if(check1.getState())
            strGlobal=null;
        else
            strGlobal=choice1.getSelectedItem();
        dispose();
    }
    public void clickedButton2() {
        // to do: put event handler code here.
        dispose();
    }
}


