/*
    This class is a basic extension of the Dialog class.  It can be used
    by subclasses of Frame.  To use it, create a reference to the class,
    then instantiate an object of the class (pass 'this' in the constructor),
    and call the show() method.

    example:

    jurusan thejurusan;
    thejurusan = new jurusan(this);
    thejurusan.show();

    You can add controls to AboutBox with Cafe Studio.
    (Menus can be added only to subclasses of Frame.)
 */

import java.awt.*;
import java.sql.*;
import java.util.*;

public class jurusan extends Dialog {

    Statement s;

    public jurusan(Frame parent, Statement s) {

	    super(parent, "Jurusan", true);

	    this.s=s;

	    //{{INIT_CONTROLS
        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 359, insets().top + insets().bottom + 178);
        list1=new List();
        add(list1);
        list1.reshape(insets().left + 21,insets().top + 65,210,71);
        edit1=new TextField(5);
        add(edit1);
        edit1.reshape(insets().left + 21,insets().top + 26,49,19);
        button1=new Button("Add");
        add(button1);
        button1.reshape(insets().left + 266,insets().top + 39,70,19);
        button2=new Button("Delete");
        add(button2);
        button2.reshape(insets().left + 266,insets().top + 71,70,20);
        button3=new Button("Close");
        add(button3);
        button3.reshape(insets().left + 266,insets().top + 117,70,19);
        label1=new Label("Kode");
        add(label1);
        label1.reshape(insets().left + 14,insets().top + 6,49,14);
        label2=new Label("Nama");
        add(label2);
        label2.reshape(insets().left + 84,insets().top + 6,49,13);
        edit2=new TextField(18);
        add(edit2);
        edit2.reshape(insets().left + 91,insets().top + 26,154,19);
        //}}

        try {
            ResultSet rs = s.executeQuery("select * from jurusan");
            while(rs.next())
            {
                list1.add(rs.getString(1)+" | "+rs.getString(2));
            }
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}

    	setResizable(false);
    }

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {
    	if (event.id == Event.ACTION_EVENT && event.target == button3) {
    	    	clickedButton3();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == button2) {
    	    	clickedButton2();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == button1) {
    	    	clickedButton1();
    	    	return true;
    	}
    	else
    	if (event.id == Event.GOT_FOCUS && event.target == list1) {
    	    	gotFocusList1(event);
    	    	return true;
    	}
    	else

    	if (event.id == Event.WINDOW_DESTROY) {
    	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
    List list1;
    TextField edit1;
    TextField edit2;
    Button button1;
    Button button2;
    Button button3;
    Label label1;
    Label label2;
    //}}
    public void gotFocusList1(Event ev) {
        // to do: put event handler code here.
    }
    public void clickedButton1() {
        // to do: put event handler code here.
        String l1 = edit1.getText();
        String l2 = edit2.getText();
        list1.add(l1+" | "+l2);
        try {
            s.executeUpdate("insert into jurusan values ( '"+l1+"','"+l2+"')");
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
    }
    public void clickedButton2() {
        // to do: put event handler code here.
        String l=list1.getSelectedItem();
        StringTokenizer st = new StringTokenizer(l, "| ");
        String kodejur = st.nextToken();

        list1.remove(l);
        try {
            s.executeUpdate("delete from jurusan where kodejur = '"+kodejur+"'");
            s.executeUpdate("delete from mahasiswa where kodejur = '"+kodejur+"'");
            s.executeUpdate("delete from kuliah where kodejur = '"+kodejur+"'");
            s.executeUpdate("delete from frs where kodejur = '"+kodejur+"'");
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
		dispose();
    }
    public void clickedButton3() {
        // to do: put event handler code here.
        dispose();
    }
}


