/*
    This class is a basic extension of the Dialog class.  It can be used
    by subclasses of Frame.  To use it, create a reference to the class,
    then instantiate an object of the class (pass 'this' in the constructor),
    and call the show() method.

    example:

    klh_cari theklh_cari;
    theklh_cari = new klh_cari(this);
    theklh_cari.show();

    You can add controls to AboutBox with Cafe Studio.
    (Menus can be added only to subclasses of Frame.)
 */

import java.awt.*;
import java.sql.*;

public class klh_cari extends Dialog {

    Statement s;
    int kmode,kstate;
    String oldkode, oldnama;

    public klh_cari(Frame parent, String title, Statement s, int kmode, String strGlobal) {

	    super(parent, title, true);

        this.s=s;
        this.kmode=kmode;
        kstate=1;

	    //{{INIT_CONTROLS
	    setLayout(null);
	    addNotify();
	    resize(insets().left + insets().right + 378, insets().top + insets().bottom + 174);
	    group1= new CheckboxGroup();
	    check1=new Checkbox("Kode",group1, true);
	    add(check1);
	    check1.reshape(insets().left + 4,insets().top + 26,87,18);
	    edit1=new TextField(19);
	    add(edit1);
	    edit1.reshape(insets().left + 100,insets().top + 29,164,28);
	    check2=new Checkbox("Nama",group1, false);
	    add(check2);
	    check2.reshape(insets().left + 4,insets().top + 55,87,20);
	    edit2=new TextField(19);
	    add(edit2);
	    edit2.reshape(insets().left + 100,insets().top + 55,164,28);
	    choice1= new Choice();
	    add(choice1);
	    choice1.reshape(insets().left + 100,insets().top + 85,112,26);
	    label6=new Label("Jurusan");
	    add(label6);
	    label6.reshape(insets().left + 28,insets().top + 85,56,19);
	    button1=new Button("Find");
	    add(button1);
	    button1.reshape(insets().left + 144,insets().top + 114,91,26);
	    button2=new Button("Close");
	    add(button2);
	    button2.reshape(insets().left + 249,insets().top + 114,91,26);
	    //}}
	    clickedCheck1();
        if(strGlobal==null)
        {
            try {
                ResultSet rs = s.executeQuery("select * from jurusan");
                while(rs.next())
                {
                    choice1.add(rs.getString(1));
                }
    		} catch (SQLException e) {
    		    System.out.println("Exception: " + e.toString());
    		}
		}
		else
		{
		    choice1.add(strGlobal);
		    choice1.setEnabled(false);
		}
    	setResizable(false);

    }

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {
    	if (event.id == Event.ACTION_EVENT && event.target == check2) {
    	    	clickedCheck2();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == check1) {
    	    	clickedCheck1();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == button2) {
    	    	clickedButton2();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == button1) {
    	    	clickedButton1();
    	    	return true;
    	}
    	else

    	if (event.id == Event.WINDOW_DESTROY) {
    	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }


    //{{DECLARE_CONTROLS
    CheckboxGroup group1;
    TextField edit1;
    TextField edit2;
    Button button1;
    Button button2;
    Checkbox check1;
    Checkbox check2;
    Choice choice1;
    Label label6;
    //}}

    public void clickedButton1() {
        // to do: put event handler code here.
        try {
            if(kstate==1)
            {
                ResultSet rs;
                String tmp;
                if(check1.getState())
                    tmp = "select * from kuliah where kode = '"+edit1.getText().trim()+"' and kodejur = '"+choice1.getSelectedItem().trim()+"'";
                else
                    tmp = "select * from kuliah where nama = '"+edit2.getText().trim()+"' and kodejur = '"+choice1.getSelectedItem().trim()+"'";
//                System.out.println(tmp);
                rs = s.executeQuery(tmp);
                if(rs.next())
                {
                    edit1.setText(rs.getString(1));
                    edit2.setText(rs.getString(2));
                    oldkode=edit1.getText();
                    oldnama=edit2.getText();
                }
                else
                {
                    DMesg d = new DMesg((Frame)getParent(),"Error","Kode atau Nama tidak ketemu !");
                    d.show();
                    return;
                }
                check1.setEnabled(false);
                check2.setEnabled(false);
                switch(kmode)
                {
                    case 1:
                        button1.setLabel("Update");
                        edit1.setEnabled(true);
                        edit2.setEnabled(true);
                        break;
                    case 2:
                        button1.setLabel("Delete");
                        edit1.setEnabled(false);
                        edit2.setEnabled(false);
                        break;
                    case 3:
                        button1.setVisible(false);
                        edit1.setEnabled(false);
                        edit2.setEnabled(false);
                        break;
                }
                kstate=2;
                choice1.setEnabled(false);
            } else if(kstate==2)
            {
                if(edit1.getText().equals("") || edit2.getText().equals(""))
                {
                    DMesg d = new DMesg((Frame)getParent(),"Error","Kode atau Nama tidak boleh kosong !");
                    d.show();
                    return;
                }
                switch(kmode)
                {
                    case 1:
                        s.executeUpdate("update kuliah set kode = '"+edit1.getText().trim()+"', nama = '"+edit2.getText().trim()+"' where kode = '"+oldkode.trim()+"' and nama = '"+oldnama.trim()+"' and kodejur = '"+choice1.getSelectedItem().trim()+"'");
                        if(!oldkode.equals(edit1.getText()))
                            s.executeUpdate("update frs set kode = '"+edit1.getText().trim()+"' where kode = '"+oldkode.trim()+"' and kodejur = '"+choice1.getSelectedItem().trim()+"'");
                        break;
                    case 2:
                        s.executeUpdate("delete from kuliah where kode = '"+edit1.getText().trim()+"' and nama = '"+edit2.getText().trim()+"' and kodejur = '"+choice1.getSelectedItem().trim()+"'");
                        s.executeUpdate("delete from frs where kode = '"+edit1.getText().trim()+"' and kodejur = '"+choice1.getSelectedItem().trim()+"'");
                        break;
                }
                dispose();
            }
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
    }
    public void clickedButton2() {
        // to do: put event handler code here.
        dispose();
    }
    public void clickedCheck1() {
        // to do: put event handler code here.
        edit1.setEnabled(true);
        edit2.setEnabled(false);
    }
    public void clickedCheck2() {
        // to do: put event handler code here.
        edit1.setEnabled(false);
        edit2.setEnabled(true);
    }
}
