/*
    This class is a basic extension of the Dialog class.  It can be used
    by subclasses of Frame.  To use it, create a reference to the class,
    then instantiate an object of the class (pass 'this' in the constructor),
    and call the show() method.

    example:

    klh_tambah theklh_tambah;
    theklh_tambah = new klh_tambah(this);
    theklh_tambah.show();

    You can add controls to AboutBox with Cafe Studio.
    (Menus can be added only to subclasses of Frame.)
 */

import java.awt.*;
import java.sql.*;

public class klh_tambah extends Dialog {

    Statement s;

    public klh_tambah(Frame parent, Statement s, String strGlobal) {

	    super(parent, "Kuliah Tambah",true);

        this.s=s;

	    //{{INIT_CONTROLS
        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 378, insets().top + insets().bottom + 174);
        edit1=new TextField(19);
        add(edit1);
        edit1.reshape(insets().left + 100,insets().top + 29,164,28);
        edit2=new TextField(19);
        add(edit2);
        edit2.reshape(insets().left + 100,insets().top + 57,164,28);
        label1=new Label("Kode");
        add(label1);
        label1.reshape(insets().left + 28,insets().top + 33,65,19);
        label2=new Label("Nama");
        add(label2);
        label2.reshape(insets().left + 28,insets().top + 55,65,20);
        choice1= new Choice();
        add(choice1);
        choice1.reshape(insets().left + 100,insets().top + 86,112,26);
        label6=new Label("Jurusan");
        add(label6);
        label6.reshape(insets().left + 28,insets().top + 86,56,20);
        button1=new Button("Ok");
        add(button1);
        button1.reshape(insets().left + 144,insets().top + 114,91,26);
        button2=new Button("Cancel");
        add(button2);
        button2.reshape(insets().left + 249,insets().top + 114,91,26);
        //}}
        if(strGlobal==null)
        {
            try {
                ResultSet rs = s.executeQuery("select * from jurusan");
                while(rs.next())
                {
                    choice1.add(rs.getString(1));
                }
    		} catch (SQLException e) {
    		    System.out.println("Exception: " + e.toString());
    		}
		}
		else
		{
		    choice1.add(strGlobal);
		    choice1.setEnabled(false);
		}

    	setResizable(false);
    }

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {
    	if (event.id == Event.ACTION_EVENT && event.target == button2) {
    	    	clickedButton2();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == button1) {
    	    	clickedButton1();
    	    	return true;
    	}
    	else

    	if (event.id == Event.WINDOW_DESTROY) {
    	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
    TextField edit1;
    TextField edit2;
    Button button1;
    Button button2;
    Label label1;
    Label label2;
    Choice choice1;
    Label label6;
    //}}
    public void clickedButton1() {
        // to do: put event handler code here.
        if(edit1.getText().equals("") || edit2.getText().equals(""))
        {
            DMesg d = new DMesg((Frame)getParent(),"Error","Kode atau Nama tidak boleh kosong !");
            d.show();
            return;
        }
        try {
            s.executeUpdate("insert into kuliah values ('"+edit1.getText()+"', '"+edit2.getText()+"', '"+choice1.getSelectedItem().trim()+"')");
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
		dispose();
    }
    public void clickedButton2() {
        // to do: put event handler code here.
        dispose();
    }
}


