/*
    This class is a basic extension of the Dialog class.  It can be used
    by subclasses of Frame.  To use it, create a reference to the class,
    then instantiate an object of the class (pass 'this' in the constructor),
    and call the show() method.

    example:

    mhs_cari themhs_cari;
    themhs_cari = new mhs_cari(this);
    themhs_cari.show();

    You can add controls to AboutBox with Cafe Studio.
    (Menus can be added only to subclasses of Frame.)
 */

import java.awt.*;
import java.sql.*;

public class mhs_cari extends Dialog {

    Statement s;
    int mmode,mstate;
    String oldnrp, oldnama;

    public mhs_cari(Frame parent, String title, Statement s, int mmode, String strGlobal) {

	    super(parent, title, true);

        this.s=s;
        this.mmode=mmode;
        mstate=1;

	    //{{INIT_CONTROLS
        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 378, insets().top + insets().bottom + 180);
        group1= new CheckboxGroup();
        check1=new Checkbox("NRP",group1, true);
        add(check1);
        check1.reshape(insets().left + 14,insets().top + 24,91,18);
        edit1=new TextField(20);
        add(edit1);
        edit1.reshape(insets().left + 110,insets().top + 28,165,28);
        check2=new Checkbox("Nama",group1, false);
        add(check2);
        check2.reshape(insets().left + 14,insets().top + 54,91,19);
        edit2=new TextField(20);
        add(edit2);
        edit2.reshape(insets().left + 110,insets().top + 54,165,28);
        choice1= new Choice();
        add(choice1);
        choice1.reshape(insets().left + 110,insets().top + 83,112,26);
        label6=new Label("Jurusan");
        add(label6);
        label6.reshape(insets().left + 39,insets().top + 83,56,19);
        button1=new Button("Find");
        add(button1);
        button1.reshape(insets().left + 154,insets().top + 112,91,26);
        button2=new Button("Close");
        add(button2);
        button2.reshape(insets().left + 259,insets().top + 112,91,26);
        //}}
        clickedCheck1();
        if(strGlobal==null)
        {
            try {
                ResultSet rs = s.executeQuery("select * from jurusan");
                while(rs.next())
                {
                    choice1.add(rs.getString(1));
                }
    		} catch (SQLException e) {
    		    System.out.println("Exception: " + e.toString());
    		}
		}
		else
		{
		    choice1.add(strGlobal);
		    choice1.setEnabled(false);
		}

    	setResizable(false);
    }

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {
    	if (event.id == Event.ACTION_EVENT && event.target == check2) {
    	    	clickedCheck2();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == check1) {
    	    	clickedCheck1();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == button2) {
    	    	clickedButton2();
    	    	return true;
    	}
    	else
    	if (event.id == Event.ACTION_EVENT && event.target == button1) {
    	    	clickedButton1();
    	    	return true;
    	}
    	else

    	if (event.id == Event.WINDOW_DESTROY) {
    	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
    CheckboxGroup group1;
    TextField edit1;
    TextField edit2;
    Button button1;
    Button button2;
    Checkbox check1;
    Checkbox check2;
    Choice choice1;
    Label label6;
    //}}
    public void clickedButton1() {
        // to do: put event handler code here.
        try {
            if(mstate==1)
            {
                ResultSet rs;
                String tmp;
                if(check1.getState())
                    tmp = "select * from mahasiswa where nrp = '"+edit1.getText().trim()+"' and kodejur = '"+choice1.getSelectedItem().trim()+"'";
                else
                    tmp = "select * from mahasiswa where nama = '"+edit2.getText().trim()+"' and kodejur = '"+choice1.getSelectedItem().trim()+"'";
//                System.out.println(tmp);
                rs = s.executeQuery(tmp);
                if(rs.next())
                {
                    edit1.setText(rs.getString(1));
                    edit2.setText(rs.getString(2));
                    oldnrp=edit1.getText();
                    oldnama=edit2.getText();
                }
                else
                {
                    DMesg d = new DMesg((Frame)getParent(),"Error","NRP atau Nama tidak ketemu !");
                    d.show();
                    return;
                }
                check1.setEnabled(false);
                check2.setEnabled(false);
                switch(mmode)
                {
                    case 1:
                        button1.setLabel("Update");
                        edit1.setEnabled(true);
                        edit2.setEnabled(true);
                        break;
                    case 2:
                        button1.setLabel("Delete");
                        edit1.setEnabled(false);
                        edit2.setEnabled(false);
                        break;
                    case 3:
                        button1.setVisible(false);
                        edit1.setEnabled(false);
                        edit2.setEnabled(false);
                        break;
                }
                mstate=2;
                choice1.setEnabled(false);
            } else if(mstate==2)
            {
                if(edit1.getText().equals("") || edit2.getText().equals(""))
                {
                    DMesg d = new DMesg((Frame)getParent(),"Error","NRP atau Nama tidak boleh kosong !");
                    d.show();
                    return;
                }
                switch(mmode)
                {
                    case 1:
                        s.executeUpdate("update mahasiswa set nrp = '"+edit1.getText()+"', nama = '"+edit2.getText()+"' where nrp = '"+oldnrp+"' and nama = '"+oldnama+"' and kodejur = '"+choice1.getSelectedItem()+"'");
                        if(!oldnrp.equals(edit1.getText()))
                            s.executeUpdate("update frs set nrp = '"+edit1.getText()+"' where nrp = '"+oldnrp+"' and kodejur = '"+choice1.getSelectedItem()+"'");
                        break;
                    case 2:
                        s.executeUpdate("delete from mahasiswa where nrp = '"+edit1.getText()+"' and nama = '"+edit2.getText()+"' and kodejur = '"+choice1.getSelectedItem()+"'");
                        s.executeUpdate("delete from frs where nrp = '"+edit1.getText()+"' and kodejur = '"+choice1.getSelectedItem()+"'");
                        break;
                }
                dispose();
            }
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
    }
    public void clickedButton2() {
        // to do: put event handler code here.
        dispose();
    }
    public void clickedCheck1() {
        // to do: put event handler code here.
        edit1.setEnabled(true);
        edit2.setEnabled(false);
    }
    public void clickedCheck2() {
        // to do: put event handler code here.
        edit1.setEnabled(false);
        edit2.setEnabled(true);
    }
}


