/*
    This class is a basic extension of the Dialog class.  It can be used
    by subclasses of Frame.  To use it, create a reference to the class,
    then instantiate an object of the class (pass 'this' in the constructor),
    and call the show() method.

    example:

    password thepassword;
    thepassword = new password(this);
    thepassword.show();

    You can add controls to AboutBox with Cafe Studio.
    (Menus can be added only to subclasses of Frame.)
 */

import java.awt.*;

public class password extends Dialog {

    public password(Frame parent,String user, String password) {

	    super(parent, "Password", true);

	    //{{INIT_CONTROLS
        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 260, insets().top + insets().bottom + 110);
        edit1=new TextField(user,20);
        add(edit1);
        edit1.reshape(insets().left + 84,insets().top + 19,168,20);
        edit2=new TextField(password,20);
        add(edit2);
        edit2.reshape(insets().left + 84,insets().top + 52,168,19);
        label1=new Label("User");
        add(label1);
        label1.reshape(insets().left + 15,insets().top + 26,55,13);
        label2=new Label("Password");
        add(label2);
        label2.reshape(insets().left + 14,insets().top + 52,63,13);
        button1=new Button("Ok");
        add(button1);
        button1.reshape(insets().left + 110,insets().top + 80,60,24);
        //}}

        edit2.setEchoChar('*');

    	setResizable(false);
    }

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public synchronized void wakeUp() {
    	notify();
    }

    public boolean handleEvent(Event event) {

    	if (event.id == Event.ACTION_EVENT && event.target == button1) {
    	    	clickedButton1();
    	    	return true;
    	}
    	if (event.id == Event.WINDOW_DESTROY) {
    	    dispose();
    	    return true;
    	}
    	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
    TextField edit1;
    TextField edit2;
    Label label1;
    Label label2;
    Button button1;
    //}}

    public void clickedButton1() {
        // to do: put event handler code here.
        dispose();
    }

    public String getUser()
    {
        return edit1.getText();
    }

    public String getPassword()
    {
        return edit2.getText();
    }
}


