/*
    This class is an extension of the Frame class for use as the
    main window of an application.

    You can add controls or menus to junusx with Cafe Studio.
 */

import java.awt.*;
import java.sql.*;
import java.io.*;

public class sis_info_mhsklh extends Frame {

    public static void main(String argv[]) {
        new sis_info_mhsklh(argv);
    }

   	private String vcDriver[]= new String[16];
   	private int vcDriverCount;
   	private String vcDBName;
   	private String vcDBVersion;
   	private boolean vcIDDB;
   	private boolean vcIDDBLocal;

    private String strGlobal=null;
    private MenuItem menuItemJurusan;

    public sis_info_mhsklh(String argv[]) {

        super("Sistem Informasi Mahasiswa-Kuliah");

    	FileInputStream fin = null;
    	String fileIn=null;

    	if(argv.length ==1)
        	fileIn=argv[0];
    	else
        	fileIn="sis_info.ini";

        try
        {
            fin= new FileInputStream (fileIn);
            try
            {
            	DataInputStream d = new DataInputStream(fin);
            	int row=0;
            	if ( d!=null )
            	{
                	while(d.available()>0)
                    {
                        vcDriver[row]=d.readLine();
                        row++;
                    }
            	    vcDriverCount=row;
                }
                d.close();
                fin.close();
            }catch (IOException e)
            {
        	    System.out.println("Error while read file "+fileIn);
        	    vcDriver[0]="iddb.Driver";
        	    vcDriver[1]="jdbc:iddb://junus/iddb";
        	    vcDriver[2]="junus";
        	    vcDriver[3]="junarto";
        	    vcDriverCount=4;
            }
        }catch (FileNotFoundException e)
        {
    	    System.out.println("Error while try open file "+fileIn);
    	    vcDriver[0]="iddb.Driver";
    	    vcDriver[1]="jdbc:iddb://junus/iddb";
    	    vcDriver[2]="junus";
    	    vcDriver[3]="junarto";
    	    vcDriverCount=4;
        }

        //{{INIT_CONTROLS
        setLayout(null);
        addNotify();
        resize(insets().left + insets().right + 379, insets().top + insets().bottom + 180);
        //}}
    	move(50, 50);

        boolean vfExit=false;
        while(!vfExit)
        {
            password vfPassword = new password(this,vcDriver[2],vcDriver[3]);
            vfPassword.show();
            vcDriver[2]=vfPassword.getUser();
            vcDriver[3]=vfPassword.getPassword();
            vfExit=initdb(vcDriver);
            if(!vfExit)
            {
                DMesg d = new DMesg(this,"Error","User atau Password salah !",true);
                d.show();
            }
        }
        try
        {
            DatabaseMetaData vfDMD=db.getMetaData();
            vcDBName=vfDMD.getDriverName();
            vcDBVersion=vfDMD.getDriverVersion();
            if(vcDBName.indexOf("IDDB")>-1)
            {
                vcIDDB=true;
                if(vcDBName.indexOf("Local")>-1)
                {
                    ResultSet rs=s.executeQuery("select kodejur from jurusan");
                    if(rs.next())
                    {
                        strGlobal=rs.getString(1);
                        vcIDDBLocal=true;
                    }
                    else
                        vcIDDBLocal=false;
                }
//                if(vcDBName.indexOf("Global")>-1)
            }
            else
            {
                vcIDDB=false;
                vcIDDBLocal=false;
            }
        }catch (SQLException e)
        {
    	    System.out.println("Error : "+fileIn);
        }


        //{{INIT_MENUS
        MenuBar mb = new MenuBar();
        menu1 = new Menu("File");
        menu5 = new Menu("Mahasiswa");
        menu5.add(new MenuItem("Tambah"));
        menu5.add(new MenuItem("Ubah"));
        menu5.add(new MenuItem("Hapus"));
        menu5.add(new MenuItem("Tampil"));
        menu1.add(menu5);
        menu2 = new Menu("Kuliah");
        menu2.add(new MenuItem("Tambah"));
        menu2.add(new MenuItem("Ubah"));
        menu2.add(new MenuItem("Hapus"));
        menu2.add(new MenuItem("Tampil"));
        menu1.add(menu2);
        menu6 = new Menu("FRS");
        menu6.add(new MenuItem("Tambah"));
        menu6.add(new MenuItem("Ubah"));
        menu6.add(new MenuItem("Hapus"));
        menu6.add(new MenuItem("Tampil"));
        menu1.add(menu6);
        if(!vcIDDBLocal)
        {
    	    menuItemJurusan=new MenuItem("Jurusan");
            menu1.add(menuItemJurusan);
        }
        menu1.addSeparator();
        menu1.add(new MenuItem("Exit"));
        mb.add(menu1);
        menu3 = new Menu("Report");
        menu3.add(new MenuItem("Mahasiswa"));
        menu3.add(new MenuItem("Kuliah"));
        menu3.add(new MenuItem("FRS"));
        menu3.add(new MenuItem("FRS ?"));
        mb.add(menu3);
        if(!vcIDDBLocal)
        {
            menu7 = new Menu("Option");
            menu7.add(new MenuItem("Global"));
            menu7.addSeparator();
            if(!vcIDDB)
            {
                menu7.add(new MenuItem("Create Table"));
                menu7.add(new MenuItem("Drop Table"));
            }
            else
            {
                menu7.add(new MenuItem("IDDB: Ext Create Table"));
                menu7.add(new MenuItem("IDDB: Ext Drop Table"));
            }
            mb.add(menu7);
        }
        menu4 = new Menu("Help");
        menu4.add(new MenuItem("About"));
        mb.add(menu4);
        setMenuBar(mb);
        //}}

        show();
    }

    Connection db;
    Statement s;
    private boolean initdb(String vpDriver[])
    {
//	    String ddrv = "postgresql.Driver";
//          String durl = "jdbc:postgresql://junus/iddb";
//	    	    String ddrv = "interbase.interclient.Driver";
//                    String durl = "jdbc:interbase://junus/d:\\iddb.gdb";
//	    String duser = "junus";
//	    String dpassword = "junarto";

		try
		{
			Class.forName(vpDriver[0]);
		} catch (ClassNotFoundException e) {
			System.err.println("Exception: " + e.toString());
		    return false;
		}

		try
		{
		    db = DriverManager.getConnection(vpDriver[1], vpDriver[2], vpDriver[3]);
		    s = db.createStatement();
		} catch (SQLException e) {
//		    System.out.println("Exception: " + e.toString());
		    return false;
		}
		return true;
    }

    public synchronized void show() {
    	move(50, 50);
    	super.show();
    }

    public boolean handleEvent(Event event) {

    	if (event.id == Event.WINDOW_DESTROY) {
            selectedExit();
            return true;
    	}
    	return super.handleEvent(event);
    }

    //{{DECLARE_MENUS
    Menu menu1;
    Menu menu5;
    Menu menu2;
    Menu menu6;
    Menu menu3;
    Menu menu7;
    Menu menu4;
    //}}

    //{{DECLARE_CONTROLS
    //}}

    public boolean action(Event event, Object arg) {
        if (event.target instanceof MenuItem) {
            String label = (String) arg;
            String parent = ((Menu) ((MenuItem) event.target).getParent()).getLabel();
            if (parent.equalsIgnoreCase("Mahasiswa"))
            {
                if (label.equalsIgnoreCase("Tampil")) {
                    selectedMhsCari(3);
                    return true;
                } else if (label.equalsIgnoreCase("Hapus")) {
                    selectedMhsCari(2);
                    return true;
                } else if (label.equalsIgnoreCase("Ubah")) {
                    selectedMhsCari(1);
                    return true;
                } else if (label.equalsIgnoreCase("Tambah")) {
                    selectedMhsTambah();
                    return true;
                }
            } else if (parent.equalsIgnoreCase("Kuliah"))
            {
                if (label.equalsIgnoreCase("Tampil")) {
                    selectedKlhCari(3);
                    return true;
                } else if (label.equalsIgnoreCase("Hapus")) {
                    selectedKlhCari(2);
                    return true;
                } else if (label.equalsIgnoreCase("Ubah")) {
                    selectedKlhCari(1);
                    return true;
                } else if (label.equalsIgnoreCase("Tambah")) {
                    selectedKlhTambah();
                    return true;
                }
            } else if (parent.equalsIgnoreCase("FRS"))
            {
                if (label.equalsIgnoreCase("Tampil")) {
                    selectedFRSCari(3);
                    return true;
                } else if (label.equalsIgnoreCase("Hapus")) {
                    selectedFRSCari(2);
                    return true;
                } else if (label.equalsIgnoreCase("Ubah")) {
                    selectedFRSCari(1);
                    return true;
                } else if (label.equalsIgnoreCase("Tambah")) {
                    selectedFRSTambah();
                    return true;
                }
            } else if (label.equalsIgnoreCase("About")) {
                selectedAbout();
                return true;
            } else if (label.equalsIgnoreCase("Global")) {
                selectedGlobal();
                return true;
            } else if (label.equalsIgnoreCase("Jurusan")) {
                selectedJurusan();
                return true;
            } else if (label.equalsIgnoreCase("Mahasiswa")) {
                selectedReport(1);
                return true;
            } else if (label.equalsIgnoreCase("Kuliah")) {
                selectedReport(2);
                return true;
            } else if (label.equalsIgnoreCase("FRS")) {
                selectedReport(3);
                return true;
            } else if (label.equalsIgnoreCase("FRS ?")) {
                selectedReport(4);
                return true;
            } else if (label.equalsIgnoreCase("Create Table")) {
                selectedCreateTable();
                return true;
            } else if (label.equalsIgnoreCase("Drop Table")) {
                selectedDropTable();
                return true;
            } else if (label.equalsIgnoreCase("IDDB: Ext Create Table")) {
                selectedCreateTableExt();
                return true;
            } else if (label.equalsIgnoreCase("IDDB: Ext Drop Table")) {
                selectedDropTableExt();
                return true;
            } else if (label.equalsIgnoreCase("Exit")) {
                selectedExit();
                return true;
            }
        }
        return super.action(event, arg);
    }

    public void selectedExit() {
        // to do: put event handler code here.
        hide();         // hide the Frame
        dispose();      // tell windowing system to free resources
        try {
            s.close();
            db.close();
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
        System.exit(0);
    }
    public void selectedAbout() {
        // to do: put event handler code here.
        about a=new about(this,vcDBName,vcDBVersion);

        a.show();
    }
    public void selectedMhsTambah() {
        // to do: put event handler code here.
        mhs_tambah m = new mhs_tambah(this,s,strGlobal);
        m.show();
    }
    public void selectedMhsCari(int mmode) {
        // to do: put event handler code here.
        String title="Mahasiswa ";
        switch(mmode)
        {
            case 1:
                title+="Ubah";
                break;
            case 2:
                title+="Hapus";
                break;
            case 3:
                title+="Tampil";
                break;
        }
        mhs_cari m = new mhs_cari(this,title,s,mmode,strGlobal);
        m.show();
    }
    public void selectedKlhTambah() {
        // to do: put event handler code here.
        klh_tambah k = new klh_tambah(this,s,strGlobal);
        k.show();
    }
    public void selectedReport(int rmode) {
        // to do: put event handler code here.
        String title="Report ";
        switch(rmode)
        {
            case 1:
                title+="Mahasiswa";
                break;
            case 2:
                title+="Kuliah";
                break;
            case 3:
                title+="FRS";
            case 4:
                title+="FRS ?";
                break;
        }
        report r = new report(this,title,s,rmode,strGlobal);
	  if(r.getClose())
        	r.show();
    }
    public void selectedKlhCari(int mmode) {
        // to do: put event handler code here.
        String title="Kuliah ";
        switch(mmode)
        {
            case 1:
                title+="Ubah";
                break;
            case 2:
                title+="Hapus";
                break;
            case 3:
                title+="Tampil";
                break;
        }
        klh_cari k = new klh_cari(this,title,s,mmode,strGlobal);
        k.show();
    }
    public void selectedFRSTambah() {
        // to do: put event handler code here.
        frs_tambah f = new frs_tambah(this,s,strGlobal);
        f.show();
    }
    public void selectedFRSCari(int fmode) {
        // to do: put event handler code here.
        String title="FRS ";
        switch(fmode)
        {
            case 1:
                title+="Ubah";
                break;
            case 2:
                title+="Hapus";
                break;
            case 3:
                title+="Tampil";
                break;
        }
        frs_cari f = new frs_cari(this,title,s,fmode,strGlobal);
        f.show();
    }
    public void selectedCreateTable() {
        // to do: put event handler code here.
        try {
            s.executeUpdate("create table mahasiswa ( nrp char(10), nama char(30), kodejur char(3))");
            s.executeUpdate("create table kuliah ( kode char(6), nama char(30), kodejur char(3))");
            s.executeUpdate("create table frs ( nrp char(10), kode char(6), kodejur char(3))");
            s.executeUpdate("create table jurusan (kodejur char(3), nama char(20))");
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
    }
    public void selectedCreateTableExt() {
        // to do: put event handler code here.
	try{
	    if(vcDriverCount>4)
	    {
            s.executeUpdate("extended site create ti, '"+vcDriver[4]+"', "+
            "'"+vcDriver[5]+"', '"+vcDriver[6]+"', '"+vcDriver[7]+"'");
            s.executeUpdate("extended site create ti, '"+vcDriver[8]+"', "+
            "'"+vcDriver[9]+"', '"+vcDriver[10]+"', '"+vcDriver[11]+"'");
            s.executeUpdate("extended site create ti, '"+vcDriver[12]+"', "+
            "'"+vcDriver[13]+"', '"+vcDriver[14]+"', '"+vcDriver[15]+"'");
	    }
	    else
	    {
            s.executeUpdate("extended site create ti, 'interbase.interclient.Driver', "+
            "'jdbc:interbase://junus/d:\\ti.gdb', 'junus', 'junarto'");
            s.executeUpdate("extended site create tc, 'interbase.interclient.Driver', "+
            "'jdbc:interbase://junus/d:\\tc.gdb', 'junus', 'junarto'");
            s.executeUpdate("extended site create te, 'interbase.interclient.Driver', "+
            "'jdbc:interbase://junus/d:\\te.gdb', 'junus', 'junarto'");
        }

    	selectedCreateTable();

        s.executeUpdate("extended table create mahasiswa site ti fragment kodejur = '250'");
        s.executeUpdate("extended table create mahasiswa site tc fragment kodejur = '260' default");
        s.executeUpdate("extended table create mahasiswa site te fragment kodejur = '220'");

        s.executeUpdate("extended table create kuliah site ti fragment kodejur = '250'");
        s.executeUpdate("extended table create kuliah site tc fragment kodejur = '260' default");
        s.executeUpdate("extended table create kuliah site te fragment kodejur = '220'");

        s.executeUpdate("extended table create frs site ti fragment kodejur = '250'");
        s.executeUpdate("extended table create frs site tc fragment kodejur = '260' default");
        s.executeUpdate("extended table create frs site te fragment kodejur = '220'");

        s.executeUpdate("extended table create jurusan site ti fragment kodejur = '250'");
        s.executeUpdate("extended table create jurusan site tc fragment kodejur = '260' default");
        s.executeUpdate("extended table create jurusan site te fragment kodejur = '220'");

		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
    }
    public void selectedDropTable() {
        // to do: put event handler code here.
        try {
            s.executeUpdate("drop table mahasiswa");
            s.executeUpdate("drop table kuliah");
            s.executeUpdate("drop table frs");
            s.executeUpdate("drop table jurusan");
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
    }
    public void selectedDropTableExt() {
        // to do: put event handler code here.
	try{
        s.executeUpdate("extended table drop mahasiswa site ti");
        s.executeUpdate("extended table drop mahasiswa site tc");
        s.executeUpdate("extended table drop mahasiswa site te");

        s.executeUpdate("extended table drop kuliah site ti");
        s.executeUpdate("extended table drop kuliah site tc");
        s.executeUpdate("extended table drop kuliah site te");

        s.executeUpdate("extended table drop frs site ti");
        s.executeUpdate("extended table drop frs site tc");
        s.executeUpdate("extended table drop frs site te");

        s.executeUpdate("extended table drop jurusan site ti");
        s.executeUpdate("extended table drop jurusan site tc");
        s.executeUpdate("extended table drop jurusan site te");

        selectedDropTable();

        s.executeUpdate("extended site drop ti");
        s.executeUpdate("extended site drop tc");
        s.executeUpdate("extended site drop te");


		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
    }
    public void selectedJurusan() {
        // to do: put event handler code here.
        jurusan j = new jurusan(this,s);
        j.show();
    }
    public void selectedGlobal() {
        // to do: put event handler code here.
        global g = new global(this,s,strGlobal);
        g.show();
        strGlobal = g.getGlobal();
        if(strGlobal!=null)
            menuItemJurusan.setEnabled(false);
        else
            menuItemJurusan.setEnabled(true);
    }
}
