import java.io.*;
import java.sql.*;
import java.util.*;
import java.security.*;


public class user
{
    private FileConfig fc;

  	private String ddrv;
	private String durl;
	private String duser;
	private String dpassword;
	private Connection db;
	private Statement s;


   public void init() throws IOException
   {
        fc= new FileConfig();
    	  Properties pdbmsprimary = fc.getDBMSPrimary();
        ddrv=pdbmsprimary.getProperty("driver");
        durl=pdbmsprimary.getProperty("url");
        duser=pdbmsprimary.getProperty("user");
        dpassword=pdbmsprimary.getProperty("password");

        initdb();
   }

	public static void main(String argv[]) throws IOException
	{
        user u = new user();
        u.run(argv);
    }

    String encrypt(String user, String passin)
    {
        if(passin.length()!=0)
        {
            byte[] buser=user.getBytes();
            byte[] bpassin=passin.getBytes();
            int totaluser=0;
            for(int i=0;i<buser.length;i++)
                totaluser+=buser[i];
            totaluser%=bpassin.length;
            byte[] bresult=new byte[bpassin.length];
            for(int i=0;i<bpassin.length;i++)
                bresult[(totaluser+i)%bpassin.length]=bpassin[bpassin.length-i-1];
            return new String(bresult);
        }
        return "";
    }

    String decrypt(String user, String passout)
    {
        byte[] buser=user.getBytes();
        byte[] bpassout=passout.getBytes();
        int totaluser=0;
        for(int i=0;i<buser.length;i++)
            totaluser+=buser[i];
        totaluser%=bpassout.length;
        byte[] bresult=new byte[bpassout.length];
        for(int i=0;i<bpassout.length;i++)
            bresult[bpassout.length-i-1]=bpassout[(totaluser+i)%bpassout.length];
        return new String(bresult);
    }

    public void run(String argv[])
    {

        if(argv.length<1)
        {
            help();
            return;
        }
        else
        {
            argv[0]=argv[0].toLowerCase();
            if(!argv[0].equals("print")&&(argv.length<2))
            {
                help();
                return;
            }
        }


        DataInputStream InputKey=new DataInputStream(System.in);

        String user=null;
        if(argv.length>=2)
            user=argv[1];
        String password=null;
        int level=0;
        try
        {
            try
            {
                init();
                if(argv[0].equals("add"))
                {
                    System.out.print("Password : ");
                    password=InputKey.readLine();
                    System.out.print("Level ( 0:SYSDBA, 1:ROOT, 2:USER, 3:GUEST) integer value(0-3)) : ");
                    level=Integer.valueOf(InputKey.readLine()).intValue();
        			s.executeUpdate("insert into iddbuser values ('"+user+"', '"+encrypt(user,password)+"', "+level+")");
                }
                else if(argv[0].equals("del"))
                {
        			s.executeUpdate("delete from iddbuser where iuser='"+argv[1]+"'");
                }
                else if(argv[0].equals("modify"))
                {
                    System.out.print("Password : ");
                    password=InputKey.readLine();
                    System.out.print("Level ( 0:SYSDBA, 1:ROOT, 2:USER, 3:GUEST) integer value(0-3)) : ");
                    level=Integer.valueOf(InputKey.readLine()).intValue();
        			s.executeUpdate("update iddbuser set ipassword = '"+encrypt(user,password)+"', ilevel = "+level+" where iuser = '"+user+"'");
                }
                else if(argv[0].equals("print"))
                {
        		    ResultSet rs = s.executeQuery("select * from iddbuser");
        		    System.out.println("iuser                * ipassword                                          *ilv");
        		    while (rs.next())
        		    {
        		        System.out.print(rs.getString(1)+" | ");
        		        System.out.print(rs.getString(2)+" | ");
        		        System.out.println(rs.getInt(3));
        		    }
        		}
                close();
    		} catch (IOException e) {
    		    System.out.println("Exception: " + e.toString());
    		}
		} catch (SQLException e) {
		    try
		    {
    		    System.out.println("Create a new table iddbuser");

    			s.executeUpdate("CREATE TABLE IDDBUSER (IUSER CHAR(20) NOT NULL , IPASSWORD CHAR(50), ILEVEL INTEGER)");
                if(argv[0].equals("add"))
        			s.executeUpdate("insert into iddbuser values ('"+user+"', '"+encrypt(user,password)+"', "+level+")");
                else if(argv[0].equals("modify"))
        			s.executeUpdate("update iddbuser set ipassword = '"+encrypt(user,password)+"', ilevel = "+level+" where iuser = '"+user+"'");
    			try
    			{
        			close();
        		} catch (IOException ea) {
        		    System.out.println("Exception: " + ea.toString());
        		}
		    } catch (SQLException ea) {
    		    System.out.println("Exception: " + ea.toString());
    		}
		}
    }

    public void help()
    {
        System.out.println("IDDB user manajemen program, version 0.1.0 (alpha)");
        System.out.println("(c) Junus Junarto D, 1998");
        System.out.println("Institut Teknologi Sepuluh Nopember (ITS), Surabaya, Indonesia");
        System.out.println("");
        System.out.println("user (ADD|DEL|MODIFY|PRINT) username");
		System.out.println("ADD     : untuk menambah user.");
		System.out.println("DEL     : untuk menghapus user.");
		System.out.println("MODIFY  : untuk mengganti password user.");
		System.out.println("PRINT   : untuk menampilkan semua user.");
        System.out.println("  Level   : 0:SYSDBA | 1:ROOT | 2:USER | 3:GUEST");
        System.out.println("  SYSDBA  : dapat melakukan semua perintah-perintah yang ada di server IDDB.");
        System.out.println("  ROOT    : dapat membuat/menghapus table, update, dan baca data.");
        System.out.println("  USER    : dapat akses update dan baca data.");
        System.out.println("  GUEST   : hanya akses baca data.");
    }

    void close() throws IOException
    {
        closedb();
    }

    private void initdb()
    {
		try
		{
			Class.forName(ddrv);
		} catch (ClassNotFoundException e) {
			System.err.println("Exception: " + e.toString());
		}

		try
		{
		    db = DriverManager.getConnection(durl, duser, dpassword);
		    s = db.createStatement();
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
    }

    public void closedb()
    {
        try
        {
		    s.close();
		    db.close();
		} catch (SQLException e) {
		    System.out.println("Exception: " + e.toString());
		}
	}
}
